"	***** Smalltalk chunk source generated June 12, 2000 at 5:54:47 pm *****	"!

"
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the 'License'); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an 'AS
IS' basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is Operation Model Support.

The Initial Developer of the Original Code is Paul Baumann.  
Portions created by Paul Baumann are
Copyright (C) 2000, Paul L. Baumann.  All
Rights Reserved.

Contributor(s):

"!

"	***** Prerequisites *****	
		PlbStateReplicationProtocol 2.1 006
"!

"	***** Included versions *****	"!
"	PlbOperationModelSupport 2.1 002		"!
"		RtcExecutionComponents (plb)1.0 001.0		"!
"			RtcExecutionComponentsVW (plb)1.0 001.0		"!
"		RtcParserComponents (plb)1.0 001.0		"!
"		RtcParseTreeVisitationSupport (plb)1.0 001.0		"!
"		RtcPortableBehaviors (plb)1.0 001.1		"!
"		RtcProxyMethodSupport (plb)1.0 001.0		"!
"			RtcProxyMethodSupportVW (plb)1.0 001.0		"!
"		RtcScriptSupport (plb)1.0 001.1		"!
"			RtcScriptSupportVW (plb)1.0 001.0		"!

"	***** Pre-load code *****	"!

"PlbOperationModelSupport"
"Note: #declarePoolDictionary: is an ENVY method."
	"Note: #declareVariable: is an ENVY method."
	(Smalltalk declarePoolDictionary: #RtcCompilerConstants) value
		declareVariable: #ExRtcAll;
		declareVariable: #ExRtcWarning;
		declareVariable: #ExRtcError;
		yourself.
	Smalltalk declareVariable: #RtcPortal.!

"	***** Namespace variable declarations *****	"!

Smalltalk at: #RtcPortal ifAbsent: [Smalltalk at: #RtcPortal put: nil].!

"	***** Class declarations *****	"!

BlockClosure subclass: #RtcBlockContext
	instanceVariableNames: 'block data '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RtcExecutionComponents-RtcExecutionComponentsVW'!

CompiledMethod variableSubclass: #RtcCompiledMethodProxy
	instanceVariableNames: ''
	classVariableNames: 'ProxyMethodTemplates '
	poolDictionaries: ''
	category: 'RtcProxyMethodSupport-RtcProxyMethodSupportVW'!

ParagraphEditor subclass: #RtcParagraphEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RtcProxyMethodSupport-RtcProxyMethodSupportVW'!

Object subclass: #RtcCodedCachedExecution
	instanceVariableNames: 'tokenCollection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport-RtcParserComponents'!

Object subclass: #RtcCodedSymbol
	instanceVariableNames: 'symbol '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport-RtcParserComponents'!

RtcCodedSymbol subclass: #RtcCodedAtom
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport-RtcParserComponents'!

Object subclass: #RtcCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport-RtcParserComponents'!

Object subclass: #RtcExecutable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'RtcCompilerConstants '
	category: 'PlbOperationModelSupport'!

RtcExecutable subclass: #RtcBlock
	instanceVariableNames: 'statements dataSockets argCount '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcBlock variableSubclass: #RtcCompiledMethod
	instanceVariableNames: 'methodClass selector source '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcExecutable subclass: #RtcCachedExecution
	instanceVariableNames: 'cachedObject executable '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcExecutable subclass: #RtcDataConstraint
	instanceVariableNames: ''
	classVariableNames: 'SystemDefault '
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcDataConstraint subclass: #RtcDeclaredDataConstraint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcDataConstraint subclass: #RtcDerivedDataConstraint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcExecutable variableSubclass: #RtcMessageCascade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcMessageCascade variableSubclass: #RtcDirectedMessage
	instanceVariableNames: 'receiver '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcMessageCascade variableSubclass: #RtcSuperclassMessage
	instanceVariableNames: 'methodClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcExecutable subclass: #RtcMethodExit
	instanceVariableNames: 'executable '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcExecutable subclass: #RtcReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcReference subclass: #RtcInstanceReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcReference subclass: #RtcMethodIndexedVariable
	instanceVariableNames: 'indexOffset '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcReference subclass: #RtcNamedVariable
	instanceVariableNames: 'dataConstraint key '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcNamedVariable subclass: #RtcArgument
	instanceVariableNames: 'dataIndex '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcNamedVariable subclass: #RtcInstanceNamedVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcNamedVariable subclass: #RtcTemporaryVariableReference
	instanceVariableNames: 'dataIndex '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcReference subclass: #RtcNamespaceReference
	instanceVariableNames: 'namespace key executable '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcReference subclass: #RtcParentContextIndex
	instanceVariableNames: 'indexOffset dataReference '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcExecutable subclass: #RtcUnaryMessage
	instanceVariableNames: 'selector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcUnaryMessage subclass: #RtcBinaryMessage
	instanceVariableNames: 'argument '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcBinaryMessage subclass: #RtcDirectedBinaryMessage
	instanceVariableNames: 'receiver '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcUnaryMessage subclass: #RtcDirectedUnaryMessage
	instanceVariableNames: 'receiver '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcUnaryMessage variableSubclass: #RtcKeywordMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcKeywordMessage variableSubclass: #RtcDirectedKeywordMessage
	instanceVariableNames: 'receiver '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcExecutable subclass: #RtcVariableAssignment
	instanceVariableNames: 'instanceVariableReference executable '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

Object variableSubclass: #RtcExecutionData
	instanceVariableNames: 'prefix '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

RtcExecutionData variableSubclass: #RtcMethodExecutionData
	instanceVariableNames: 'instance exitValue hasExited '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport'!

Object subclass: #RtcMethodData
	instanceVariableNames: 'literals instVarPool methodDataClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport-RtcParserComponents'!

Object subclass: #RtcParseTreeVisitor
	instanceVariableNames: 'contextStack blockStack messageStack '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport-RtcParseTreeVisitationSupport'!

Object subclass: #RtcPortableBehavior
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport-RtcPortableBehaviors'!

RtcPortableBehavior subclass: #RtcPortableBehaviorDol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport-RtcPortableBehaviors'!

RtcPortableBehavior subclass: #RtcPortableBehaviorStx
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport-RtcPortableBehaviors'!

RtcPortableBehavior subclass: #RtcPortableBehaviorVa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport-RtcPortableBehaviors'!

RtcPortableBehavior subclass: #RtcPortableBehaviorVw
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport-RtcPortableBehaviors'!

Object subclass: #RtcProxyCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RtcProxyMethodSupport-RtcProxyMethodSupportVW'!

Object subclass: #RtcSmalltalkParser
	instanceVariableNames: 'activeVarPool '
	classVariableNames: 'ParserException '
	poolDictionaries: ''
	category: 'PlbOperationModelSupport-RtcParserComponents'!

WriteStream subclass: #RtcIndentedWriteStream
	instanceVariableNames: 'indentLevelCount '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlbOperationModelSupport-RtcScriptSupport'!

ComposedTextView subclass: #RtcWorkspace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RtcProxyMethodSupport-RtcProxyMethodSupportVW'!


"	***** Behavior declarations *****	"!

!Object methodsFor: 'PlbOperationModelSupport'!

indexCopyFrom: start to: end

	| answer |
	answer := Array new: (1 + end - start).
	start to: end do: [:index |
		answer 
			at: (1 + index - start) 
			put: (self at: index)
	].
	^answer!

indexOf: anObject

	1 to: self size do: [:index |
		(self at: index) = anObject ifTrue: [ ^index ].
	].
	^0
! !

!RtcArgument methodsFor: 'As yet unclassified'!

dataIndex

	^dataIndex
!

dataIndex: integer

	dataIndex := integer
!

isArgument

	^true! !

!RtcBinaryMessage methodsFor: 'As yet unclassified'!

argCount

	^1
!

argument

	^argument
!

argument: arg

	argument := arg
!

arguments

	^Array with: self argument
!

asDirectedWithReceiver: anObject

	^RtcDirectedBinaryMessage
		receiver: anObject
		selector: self selector
		argument: self argument
! !

!RtcBinaryMessage class methodsFor: 'As yet unclassified'!

selector: aSymbol argument: argument

	^self new
		selector: aSymbol;
		argument: argument;
		yourself
! !

!RtcBlock methodsFor: 'As yet unclassified'!

argCount

	^argCount!

argCount: integer

	argCount := integer

!

argumentSockets

	^dataSockets 
		indexCopyFrom: 1
		to: argCount!

dataSockets

	^dataSockets!

dataSockets: anRtcExecutionData

	dataSockets := anRtcExecutionData!

statements

	^statements
!

statements: anArray

	statements := anArray asArray
!

tempCount

	^dataSockets size - argCount!

temporarySockets

	^dataSockets 
		indexCopyFrom: argCount + 1
		to: dataSockets size! !

!RtcCachedExecution methodsFor: 'As yet unclassified'!

executable 

	^executable!

executable: rtcExec

	executable := rtcExec! !

!RtcCachedExecution class methodsFor: 'As yet unclassified'!

executable: executable

	^self new 
		executable: executable! !

!RtcCompiledMethod methodsFor: 'As yet unclassified'!

argumentCount

	"Blocks use #argCount and methods use #argumentCount,
	 but they are both the same."

	^self argCount
!

dataSockets: anRtcExecutionData

	| newLiterals |
	newLiterals := anRtcExecutionData prefix methodData.
	1 to: self size do: [:index |
		self at: index put: (newLiterals at: index).
	].
	dataSockets := anRtcExecutionData prefix: self.
!

exitSocket

	^dataSockets at: 2!

instanceSocket

	^dataSockets at: 1!

isPrivate
		"Return whether the method is private not public."

	^false!

isPublic
		"Return whether the method is public not private."

	^self isPrivate not!

methodClass

	^methodClass!

methodClass: aClass

	methodClass := aClass!

methodData

	^self allLiterals

!

methodDataAt: index

	^self at: index
!

printOn: aStream
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	aStream nextPut: ${.
	self methodClass printOn: aStream.
	aStream nextPutAll: '>>'.
	self selector printOn: aStream.
	aStream nextPut: $}.

!

returnType
	"Answer a symbol representing the class of the return
	 type or #self if the receiver will always be returned."

	^#self
!

selector

	^selector!

selector: aSymbol

	selector := aSymbol!

sourceString: string

	"source := string"!

storeOn: aStream
	"Append aStream with a representation of the receiver."

	self methodClass storeOn: aStream.
	aStream nextPutAll: '>>'.
	self selector storeOn: aStream! !

!RtcDataConstraint methodsFor: 'As yet unclassified'!

dataType
	"Answer a class that is the highest level of all valid
	 data types."

	^Object
!

dataTypes
	"Answer a collection of all valid data types."

	^#(Object)
!

isValid: anInstance

	^true
! !

!RtcDataConstraint class methodsFor: 'As yet unclassified'!

systemDefault
	"Answer a system unique instance of the receiver."

	SystemDefault isNil ifTrue: [ SystemDefault := RtcDataConstraint new ].
	^SystemDefault

! !

!RtcDirectedBinaryMessage methodsFor: 'As yet unclassified'!

receiver

	^receiver
!

receiver: anObject

	receiver := anObject

! !

!RtcDirectedBinaryMessage class methodsFor: 'As yet unclassified'!

receiver: anObject selector: aSymbol argument: argument

	^(self selector: aSymbol argument: argument)
		receiver: anObject
! !

!RtcDirectedKeywordMessage methodsFor: 'As yet unclassified'!

receiver

	^receiver
!

receiver: anObject

	receiver := anObject

! !

!RtcDirectedKeywordMessage class methodsFor: 'As yet unclassified'!

receiver: anObject selector: aSymbol arguments: anArray

	^(self selector: aSymbol arguments: anArray)
		receiver: anObject
! !

!RtcDirectedMessage methodsFor: 'As yet unclassified'!

receiver

	^receiver!

receiver: rec

	receiver := rec!

simplifiedMessage

	self size = 1 ifTrue: [ ^(self at: 1) asDirectedWithReceiver: self receiver ].
	^self! !

!RtcDirectedMessage class methodsFor: 'As yet unclassified'!

receiver: receiver expression: expression

	^(self expression: expression)
		receiver: receiver;
		yourself.
!

receiver: receiver expressions: anArray

	^(self expressions: anArray)
		receiver: receiver;
		yourself
! !

!RtcDirectedUnaryMessage methodsFor: 'As yet unclassified'!

receiver

	^receiver
!

receiver: anObject

	receiver := anObject

! !

!RtcDirectedUnaryMessage class methodsFor: 'As yet unclassified'!

receiver: anObject selector: aSymbol

	^(self selector: aSymbol)
		receiver: anObject
! !

!RtcExecutable methodsFor: 'As yet unclassified'!

simplifiedMessage

	"Answer the receiver since it is already simplified.
	 This message really only applies to directed messages,
	 but is defined on a superclass so it can be overridden."
! !

!RtcExecutable class methodsFor: 'copyright'!

copyright

	^'Copyright (C) 2000, Paul L. Baumann.  All Rights Reserved.'!

license

^'The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is Operation Model Support.

The Initial Developer of the Original Code is Paul Baumann.  
Portions created by Paul Baumann are
Copyright (C) 2000, Paul L. Baumann.  All
Rights Reserved.

Contributor(s):
'.! !

!RtcExecutionData methodsFor: 'Parsing'!

addArguments: args temporaries: temps


	^self class
		prefix: (self size > 0 ifTrue: [ self ] ifFalse: [ prefix ])
		arguments: args 
		temporaries: temps
!

atKey: key ifAbsent: failBlock

	| answer offset |
	answer := self
		indexDetect: [:ref | ref key = key ] 
		ifNone: [ prefix atKey: key ifAbsent: failBlock ].
	offset := self offsetTo: answer was: 0.
	^(offset > 0)
		ifFalse: [ answer ]
		ifTrue: [ RtcParentContextIndex socket: answer offset: offset ]


! !

!RtcExecutionData methodsFor: 'Execution'!

dataAt: index

	^(index > self size) 
		ifFalse: [ self at: index ]
		ifTrue:  [ prefix dataAt: index - self size ]!

dataAt: index put: value

	^(index > self size) 
		ifFalse: [ self at: index put: value ]
		ifTrue:  [ prefix dataAt: index - self size put: value ]! !

!RtcExecutionData methodsFor: 'Method Data'!

exitValue

	^prefix exitValue

!

exitValue: anObject

	prefix exitValue: anObject.! !

!RtcExecutionData methodsFor: 'Not categorized'!

indexDetect: testBlock ifNone: failBlock

	| value |
	1 to: self size do: [:index |
		(testBlock value: (value := self at: index)) ifTrue: [ ^value ].
	].
	^failBlock value
! !

!RtcExecutionData methodsFor: 'As yet unclassified'!

indexOf: anObject offset: offset

	1 to: self size do: [:index |
		(self at: index) == anObject ifTrue: [^index + offset].
	].
	^prefix 
		indexOf: anObject 
		offset: self size + offset
! !

!RtcExecutionData methodsFor: 'Method Data'!

instance

	^prefix instance!

instance: anObject

	prefix instance: anObject
!

methodData
	"This method should be removed later because
	 it is slow. It was only used for convenience."

	^prefix methodData
!

methodDataAt: index

	^prefix methodDataAt: index
! !

!RtcExecutionData methodsFor: 'Parsing'!

offsetTo: anObject was: runningTotal
	"anObject has been found in either the receiver or a prefix
	 of the receiver. Answer the offset required to correct
	 a reference to anObject."

	1 to: self size do: [:index |
		(self at: index) == anObject ifTrue: [^runningTotal].
	].
	^prefix
		offsetTo: anObject 
		was: runningTotal + self size
! !

!RtcExecutionData methodsFor: 'As yet unclassified'!

prefix

	^prefix
!

prefix: anObject

	prefix := anObject
! !

!RtcExecutionData methodsFor: 'Parsing'!

setDataIndexes

	1 to: self size do: [:index |
		(self at: index) dataIndex: index.
	].
! !

!RtcExecutionData class methodsFor: 'As yet unclassified'!

prefix: prefix arguments: args temporaries: temps

	| answer |
	answer := (self new: args size + temps size)
		prefix: prefix;
		yourself.
	1 to: args size do: [:index | 
		answer dataAt: index put: (args at: index)
	].
	1 to: temps size do: [:index | 
		answer dataAt: (args size + index) put: (temps at: index)
	].
	^answer setDataIndexes
! !

!RtcInstanceNamedVariable methodsFor: 'As yet unclassified'!

isAssignable

	^true!

isInstanceVariable

	^true! !

!RtcInstanceNamedVariable class methodsFor: 'CLDT-API'!

key: newKey

	"Answer a new instance of Association with
	 an Object, newKey as the Association key."

	 ^self new key: newKey asSymbol! !

!RtcInstanceNamedVariable class methodsFor: 'As yet unclassified'!

key: newKey value: newValue

	"Answer a new instance of Association with
	 newKey as the Association key and newValue
	 as the value of the association."

	 ^(self key: newKey) instance: newValue ! !

!RtcInstanceReference methodsFor: 'As yet unclassified'!

dataIndex

	^1
!

dataIndex: integer

	"Do nothing"
!

isInstanceSocket

	^true
!

key

	^#self
! !

!RtcKeywordMessage methodsFor: 'As yet unclassified'!

argCount

	^self size
!

arguments

	| answer |
	answer := Array new: self size.
	1 to: self size do: [:index |
		answer 
			at: index 
			put: (self at: index).
	].
	^answer
!

asDirectedWithReceiver: anObject

	^RtcDirectedKeywordMessage
		receiver: anObject
		selector: self selector
		arguments: self arguments
! !

!RtcKeywordMessage class methodsFor: 'As yet unclassified'!

selector: aSymbol arguments: anArray

	| answer |
	answer := self new: anArray size.
	answer selector: aSymbol.
	1 to: anArray size do: [:index |
		answer at: index put: (anArray at: index).
	].
	^answer

! !

!RtcMessageCascade methodsFor: 'As yet unclassified'!

cascades

	| answer |
	answer := Array new: self size.
	1 to: self size do: [:index |
		answer 
			at: index 
			put: (self at: index).
	].
	^answer
!

cascadesDo: oneArgBlock

	1 to: self size do: [:index |
		oneArgBlock value: (self at: index).
	].
!

cascadesDoWithIndex: twoArgBlock

	1 to: self size do: [:index |
		twoArgBlock value: (self at: index) value: index.
	].
! !

!RtcMessageCascade class methodsFor: 'As yet unclassified'!

expression: expression

	^(self new: 1)
		at: 1 put: expression;
		yourself.
!

expressions: anArray

	| answer |
	answer := self new: anArray size.
	1 to: anArray size do: [:index |
		answer at: index put: (anArray at: index).
	].
	^answer! !

!RtcMethodExecutionData methodsFor: 'Compiling'!

addArguments: args temporaries: temps

	^RtcExecutionData
		prefix: self
		arguments: args 
		temporaries: temps
! !

!RtcMethodExecutionData methodsFor: 'As yet unclassified'!

exitValue

	^exitValue
!

exitValue: anObject

	self markAsExitedMethod.
	exitValue := anObject.
! !

!RtcMethodExecutionData methodsFor: 'Execution'!

exitValuePrim: anObject

	exitValue := anObject
! !

!RtcMethodExecutionData methodsFor: 'As yet unclassified'!

instance

	^instance

!

instance: anObject

	instance := anObject

! !

!RtcMethodExecutionData methodsFor: 'Compiling'!

offsetTo: anObject was: runningTotal
	"anObject has been found in either the receiver or a prefix
	 of the receiver. Answer the offset required to correct
	 a reference to anObject."

	1 to: self size do: [:index |
		(self at: index) == anObject ifTrue: [^runningTotal].
	].
	^0! !

!RtcMethodExecutionData class methodsFor: 'As yet unclassified'!

newForClass: aClass arguments: args temporaries: temps

	| answer |
	answer := (self new: args size + temps size)
		instance: RtcInstanceReference new.
	1 to: args size do: [:index | 
		answer dataAt: index put: (args at: index)
	].
	1 to: temps size do: [:index | 
		answer dataAt: (args size + index) put: (temps at: index)
	].
	^answer 
		setDataIndexes;
		prefix: (RtcMethodData newForClass: aClass);
		yourself

! !

!RtcMethodExit methodsFor: 'As yet unclassified'!

executable 

	^executable!

executable: rtcExec

	executable := rtcExec! !

!RtcMethodExit class methodsFor: 'As yet unclassified'!

executable: executable

	^self new 
		executable: executable! !

!RtcMethodIndexedVariable methodsFor: 'As yet unclassified'!

indexOffset

	^indexOffset!

indexOffset: integer

	indexOffset := integer!

printOn: aStream

	aStream nextPutAll: self class name.
	aStream nextPut: $:.
	indexOffset printOn: aStream.
 
! !

!RtcMethodIndexedVariable class methodsFor: 'As yet unclassified'!

indexOffset: anInteger

	^self new
		indexOffset: anInteger

! !

!RtcNamedVariable methodsFor: 'As yet unclassified'!

dataConstraint

	^dataConstraint
!

dataConstraint: aClassName

	dataConstraint := aClassName

!

initialize

	dataConstraint := RtcDataConstraint systemDefault.

!

key

	^key
!

key: aKey

	key := aKey
! !

!RtcNamedVariable class methodsFor: 'As yet unclassified'!

new

	^self basicNew initialize
! !

!RtcNamespaceReference methodsFor: 'As yet unclassified'!

executable

	^executable
!

key

	^key
!

key: aKey

	key := aKey
!

namespace

	^namespace
!

namespace: aSymbol

	namespace := aSymbol
! !

!RtcNamespaceReference class methodsFor: 'As yet unclassified'!

namespace: aSymbol key: aKey

	^self new
		namespace: aSymbol;
		key: aKey
! !

!RtcParentContextIndex methodsFor: 'As yet unclassified'!

dataIndex

	^indexOffset + dataReference dataIndex!

dataReference 

	^dataReference!

dataReference: ref

	dataReference := ref!

indexOffset

	^indexOffset!

indexOffset: integer

	indexOffset := integer !

isAssignable

	^dataReference isAssignable
!

key

	^dataReference key! !

!RtcParentContextIndex class methodsFor: 'As yet unclassified'!

socket: ref offset: integer

	^self new
		dataReference: ref;
		indexOffset: integer;
		yourself
! !

!RtcReference methodsFor: 'As yet unclassified'!

dataIndex

	^0
!

isArgument

	^false!

isAssignable

	^false!

isInstanceSocket

	^false!

isInstanceVariable

	^false!

isTemporaryVariable

	^false! !

!RtcReference class methodsFor: 'As yet unclassified'!

key: newKey

	"Answer a new instance of Association with
	 an Object, newKey as the Association key."

	 ^(self new) key: newKey! !

!RtcSuperclassMessage methodsFor: 'As yet unclassified'!

methodClass

	^methodClass
!

methodClass: classReference

	methodClass := classReference! !

!RtcSuperclassMessage class methodsFor: 'As yet unclassified'!

methodClass: classReference expression: expression

	^(self expression: expression)
		methodClass: classReference;
		yourself.
!

methodClass: classReference expressions: anArray

	^(self expressions: anArray)
		methodClass: classReference;
		yourself
! !

!RtcTemporaryVariableReference methodsFor: 'As yet unclassified'!

dataIndex

	^dataIndex
!

dataIndex: integer

	dataIndex := integer
!

isAssignable

	^true!

isTemporaryVariable

	^true! !

!RtcUnaryMessage methodsFor: 'As yet unclassified'!

argCount

	^0
!

arguments

	^#()!

asDirectedWithReceiver: anObject

	^RtcDirectedUnaryMessage
		receiver: anObject
		selector: self selector
!

selector

	^selector!

selector: aSymbol

	selector := aSymbol! !

!RtcUnaryMessage class methodsFor: 'As yet unclassified'!

selector: aSymbol

	^self new selector: aSymbol! !

!RtcVariableAssignment methodsFor: 'As yet unclassified'!

executable 

	^executable!

executable: rtcExec

	executable := rtcExec!

instanceVariableReference

	^instanceVariableReference!

instanceVariableReference: iVarRef

	instanceVariableReference := iVarRef! !

!RtcVariableAssignment class methodsFor: 'As yet unclassified'!

socket: socket executable: executable

	^(self new)
		instanceVariableReference: socket;
		executable: executable;
		yourself! !

!Object methodsFor: 'RtcExecutionComponents'!

rtcPerformUsing: execData

	" ^self "
! !

!RtcArgument methodsFor: 'RtcExecutionComponents'!

rtcPerformUsing: execData

	^execData dataAt: dataIndex 
!

rtcSetUsing: execData to: newValue

	^execData 
		dataAt: dataIndex 
		put: newValue! !

!RtcBinaryMessage methodsFor: 'RtcExecutionComponents'!

performedArgumentsUsing: execData

	^Array with: (argument rtcPerformUsing: execData)
! !

!RtcBlock methodsFor: 'RtcExecutionComponents'!

performStatementsUsing: execData
	"Unlike a method, a block will answer the last
	 response from a statement."

	| response |
	statements do: [:statement | 
		response := statement rtcPerformUsing: execData.
	].
	^response

		
!

rtcPerformUsing: execData

	^RtcBlockContext
		block: self
		execData: (dataSockets executionCopyPrefix: execData)
! !

!RtcCachedExecution methodsFor: 'RtcExecutionComponents'!

rtcPerformUsing: execData

	cachedObject isNil ifTrue: [ cachedObject := executable rtcPerformUsing: execData ]. 
	^cachedObject! !

!RtcCompiledMethod methodsFor: 'RtcExecutionComponents'!

executeWithReceiver: anObject andArguments: anArray
	"Execute the receiver with the given receiver and
	 arguments. Fail if the class of anObject is inappropriate.
	 Fail if anArray is not an Array. Fail if the number of
	 elements in anArray is incorrect."

	| execData answer |
	(argCount = anArray size) ifFalse: [self error: 'Invalid argument count.'].
	execData := dataSockets 
		executionCopyFor: anObject 
		args: anArray.
	answer := self performStatementsUsing: execData.
	execData markAsExitedMethod.
	^(methodClass == UndefinedObject)
		ifFalse: [ execData exitValue ]
		ifTrue:  [ answer ]
!

rtcPerformUsing: execData

	" ^self "
		
! !

!RtcDirectedBinaryMessage methodsFor: 'RtcExecutionComponents'!

performedReceiverUsing: execData

	^self receiver rtcPerformUsing: execData
!

rtcPerformUsing: execData
		"Send the message represented by the receiver. Answer the
		 result of evaluating the message."

	^self 
		sendTo: (self performedReceiverUsing: execData)
		using: execData
! !

!RtcDirectedKeywordMessage methodsFor: 'RtcExecutionComponents'!

performedReceiverUsing: execData

	^self receiver rtcPerformUsing: execData
!

rtcPerformUsing: execData
		"Send the message represented by the receiver. Answer the
		 result of evaluating the message."

	^self 
		sendTo: (self performedReceiverUsing: execData)
		using: execData
! !

!RtcDirectedMessage methodsFor: 'RtcExecutionComponents'!

performedReceiverUsing: execData

	^self receiver rtcPerformUsing: execData
!

sendTo: recipient using: execData
		"Send the message represented by the receiver to anObject.
		 Answer the result of evaluating the message."

	| answer |
	self cascadesDo: [:anExpression |
		answer := anExpression 
			sendTo: recipient 
			using: execData.
	].
	^answer
! !

!RtcDirectedUnaryMessage methodsFor: 'RtcExecutionComponents'!

performedReceiverUsing: execData

	^self receiver rtcPerformUsing: execData
!

rtcPerformUsing: execData
		"Send the message represented by the receiver. Answer the
		 result of evaluating the message."

	^self 
		sendTo: (self performedReceiverUsing: execData)
		using: execData
! !

!RtcExecutionData methodsFor: 'RtcExecutionComponents'!

executionCopyPrefix: newPrefix

	^(self class new: self size)
		prefix: newPrefix;
		yourself

!

executionCopyWithArgs: anArray

	| answer |
	answer := (self class new: self size)
		prefix: self prefix;
		yourself.
	1 to: anArray size do: [:index |
		answer at: index put: (anArray at: index)
	].
	^answer!

hasExitedMethod
	"Answer boolean to whether the method for the
	 receiver has already been exited. If exited,
 	 the receiver must not take another exit value."

	^prefix hasExitedMethod
! !

!RtcInstanceNamedVariable methodsFor: 'RtcExecutionComponents'!

rtcPerformUsing: execData

	| index instance |
	index := (instance := execData instance) class allInstVarNames 
		indexOf: key asString
		ifAbsent: [ self error: 'Instance of ', instance class name, ' missing instance variable ', key ].
	^instance instVarAt: index

!

rtcSetUsing: execData to: newValue

	| index instance |
	index := (instance := execData instance) class allInstVarNames 
		indexOf: key asString
		ifAbsent: [ self error: 'Instance of ', instance class name, ' missing instance variable ', key ].
	instance instVarAt: index put: newValue.
	^newValue
! !

!RtcInstanceReference methodsFor: 'RtcExecutionComponents'!

rtcPerformUsing: execData
	"The receiver represents a placeholder for an instance.
	 Request the instance contained in execData. "

	^execData instance! !

!RtcKeywordMessage methodsFor: 'RtcExecutionComponents'!

performedArgumentsUsing: execData

	| answer |
	answer := Array new: self size.
	1 to: self size do: [:index |
		answer 
			at: index 
			put: ((self at: index) rtcPerformUsing: execData).
	].
	^answer
! !

!RtcMessageCascade methodsFor: 'RtcExecutionComponents'!

rtcPerformUsing: execData
		"Send the message represented by the receiver. Answer the
		 result of evaluating the message."

	^self 
		sendTo: (self performedReceiverUsing: execData)
		using: execData
! !

!RtcMethodExecutionData methodsFor: 'RtcExecutionComponents'!

executionCopyFor: anInstance args: anArray

	^(self executionCopyWithArgs: anArray)
		instance: anInstance;
		exitValuePrim:  anInstance;
		yourself

!

hasExitedMethod
	"Answer boolean to whether the method for the
	 receiver has already been exited. If exited,
 	 the receiver must not take another exit value."

	^hasExited == true
!

markAsExitedMethod

	hasExited := true! !

!RtcMethodExit methodsFor: 'RtcExecutionComponents'!

rtcPerformUsing: execData

	| response |
	execData hasExitedMethod 
		ifTrue: [ self error: 'attempt to return twice from method' ].
	response := executable rtcPerformUsing: execData. 
	execData hasExitedMethod 
		ifTrue: [ ^response ].
	execData exitValue: response.
	^response
! !

!RtcMethodIndexedVariable methodsFor: 'RtcExecutionComponents'!

rtcPerformUsing: execData
	"Should be able to find a better way to do this."

	| answer |
	^(answer := execData methodDataAt: indexOffset) isAssociation 
		ifTrue:  [answer value]
		ifFalse: [answer]! !

!RtcNamespaceReference methodsFor: 'RtcExecutionComponents'!

rtcPerformUsing: execData

	^executable rtcPerformUsing: execData
! !

!RtcParentContextIndex methodsFor: 'RtcExecutionComponents'!

rtcPerformUsing: execData

	^execData dataAt: (dataReference dataIndex + indexOffset)! !

!RtcSuperclassMessage methodsFor: 'RtcExecutionComponents'!

performedReceiverUsing: execData

	^execData instance
!

sendTo: recipient using: execData
		"Send the message represented by the receiver to anObject.
		 Answer the result of evaluating the message."

	| answer mClass |
	mClass := self methodClass rtcPerformUsing: execData.
	self cascadesDo: [:anExpression |
		answer := anExpression 
			superMethodOf: mClass 
			sendTo: recipient 
			using: execData.
	].
	^answer
! !

!RtcTemporaryVariableReference methodsFor: 'RtcExecutionComponents'!

rtcPerformUsing: execData

	^execData dataAt: dataIndex 
!

rtcSetUsing: execData to: newValue

	^execData 
		dataAt: dataIndex 
		put: newValue! !

!RtcUnaryMessage methodsFor: 'RtcExecutionComponents'!

performedArgumentsUsing: execData

	^#()!

sendTo: anObject using: execData
		"Send the message represented by the receiver to anObject.
		 Answer the result of evaluating the message."

	^anObject 
		perform: (selector rtcPerformUsing: execData)
		withArguments: (self performedArgumentsUsing: execData)!

superMethodOf: methodClass sendTo: anObject using: execData
	"Send the message represented by the receiver to anObject.
	 Answer the result of evaluating the message."

	| aSelector anArray superMethod |
	aSelector := selector rtcPerformUsing: execData.
	anArray := self performedArgumentsUsing: execData.
	superMethod := RtcPortal 
		behavior: methodClass superclass 
		lookupSelector: aSelector.
	superMethod isNil ifTrue: [
		^self doesNotUnderstand: (Message selector: aSelector arguments: anArray)
	].
	^RtcPortal 
		compiledMethod: superMethod 
		executeWithReceiver: anObject 
		andArguments: anArray! !

!RtcVariableAssignment methodsFor: 'RtcExecutionComponents'!

rtcPerformUsing: execData

	^instanceVariableReference 
		rtcSetUsing: execData
		to: (executable rtcPerformUsing: execData)
! !

!RtcBlockContext methodsFor: 'As yet unclassified'!

block: anRtcBlock

	block := anRtcBlock
!

data: execData

	data := execData

!

value

	^self valueWithArguments: #()!

value: anObject

	^self valueWithArguments: (
		Array with: anObject
	)
!

value: anObject value: anotherObject
		"Evaluate the receiver with parameters anObject and anotherObject.
		 Answer the result of the last statement to be evaluated."

	^self valueWithArguments: (
		Array with: anObject with: anotherObject
	)
!

value: anObject value: anotherObject value: thirdObject
		"Evaluate the receiver with parameters anObject, anotherObject and
		 thirdObject. Answer the result of the last statement to be evaluated."

	^self valueWithArguments: (
		Array with: anObject with: anotherObject with: thirdObject
	)
!

valueWithArguments: anArray
		"Evaluate the receiver with parameters anArray. Answer the
		 result of the last statement to be evaluated."

	| execData |
	(block argCount = anArray size) ifFalse: [self error: 'Invalid argument count.'].
	execData := data executionCopyWithArgs: anArray.
	^block performStatementsUsing: execData

! !

!RtcBlockContext class methodsFor: 'As yet unclassified'!

block: anRtcBlock execData: execData

	^(self new)
		block: anRtcBlock;
		data: execData;
		yourself
! !

!Character methodsFor: 'RtcParserComponents'!

isBinaryMessageCharacter
	"Answer boolean whether the receiver is considered
	 a Smalltalk binary message."

	^',+/\*~-<>=@%|&?' includes: self
!

isDigitForRadix: radixValue

	| index |
	index := '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'
		indexOf: self.
	^(index = 0 or: [ index > radixValue ]) not
! !

!Object methodsFor: 'RtcParserComponents'!

asRtcParserExecutable: aParser

	" ^self "

	^aParser literalReferenceFor: self

!

isBinaryMessageSelector

	^false
!

isKeywordMessageSelector

	^false
! !

!OrderedCollection methodsFor: 'RtcParserComponents'!

asRtcParserExecutable: aParser

	^aParser extractStatementFrom: self
!

removeFrom: startIndex to: endIndex

	| answer |
	answer := OrderedCollection new: (1 + endIndex - startIndex).
	endIndex to: startIndex by: -1 do: [:index |
		answer addFirst: (self removeAtIndex: index)
	].
	^answer
! !

!PositionableStream methodsFor: 'RtcParserComponents'!

selectWhile: testBlock

	| beginning end |
	beginning := (end := self position) + 1.
	[ self atEnd not and: [ testBlock value: self next ] ] 
		whileTrue: [ end := end + 1 ].
	^self 
		position: end;
		copyFrom: beginning to: end
! !

!RtcCodedCachedExecution methodsFor: 'As yet unclassified'!

asRtcParserExecutable: aParser
	"As this method is, the varPool contains temporaries, instance variables and arguments
	 that should not be compiled for a cached execution. This must be fixed."

	^RtcCachedExecution executable: (tokenCollection asRtcParserExecutable: aParser)

!

tokenCollection

	^tokenCollection
!

tokenCollection: aCollection

	tokenCollection := aCollection! !

!RtcCodedCachedExecution class methodsFor: 'As yet unclassified'!

tokens: tokenCollection

	^self new tokenCollection: tokenCollection
! !

!RtcCodedSymbol methodsFor: 'As yet unclassified'!

asRtcParserExecutable: aParser

	^aParser literalReferenceFor: symbol
!

symbol: aSymbol

	symbol := aSymbol

	! !

!RtcCodedSymbol class methodsFor: 'As yet unclassified'!

symbol: aSymbol

	^self new
		symbol: aSymbol! !

!RtcCompiler class methodsFor: 'Method Compile'!

compile: string inClass: aClass

	^self 
		compile: string 
		inClass: aClass
		ifFail: [:error| ]
!

compile: string inClass: aClass ifFail: oneArgBlock

	^self 
		parse: string 
		class: aClass 
		errorHandler: nil 
		ifFail: [].

!

evaluate: string
	"Compile and execute string. Answer false if 
	 compile error."

	^self 
		evaluate: string 
		for: nil
		ifFail: [:error| ^false ]
!

evaluate: string for: receiver

	^self 
		evaluate: string 
		for: receiver 
		ifFail: [:error| ]
!

evaluate: string for: receiver ifFail: failBlock

	| method |
	method := self 
		compile: ('Doit
', string) 
		inClass: receiver class 
		ifFail: failBlock.
	^RtcPortal 
		compiledMethod: method 
		executeWithReceiver: receiver
		andArguments: #()! !

!RtcCompiler class methodsFor: 'As yet unclassified'!

parse: string class: aClass errorHandler: errorHandler ifFail: failBlock

	^RtcSmalltalkParser
		parse: string 
		class: aClass 
		errorHandler: errorHandler 
		ifFail: failBlock
!

parseSTElementsFromString: codeString
	"Iterates over codeStream and answer and OrderedCollection representing ST
	 code type items found within codeStream."
	| codeStream answer |
	codeStream := ReadStream on: codeString.
	answer := OrderedCollection new.
	[ codeStream atEnd ] whileFalse: [
		((codeStream peek isDigit) or: [
				(codeStream peek = $-) and: [|tmp| tmp := codeStream next; next. codeStream skip: -2. tmp isDigit]
		]) ifTrue: [
			answer addLast: (self tokenizeSTNumberIn: codeStream).
		] ifFalse: [
			(codeStream peek = $$) ifTrue: [
				codeStream next.
				answer add: codeStream next.
			] ifFalse: [
				| subString |
				(codeStream peek = $') | (codeStream peek = $") ifTrue: [
					| char |
					char := codeStream next.
					subString := RtcPortal positionableStream: codeStream selectWhile: [:chr | chr ~= char ].
					(codeStream atEnd) 
					ifFalse: [
						(char = $') ifTrue: [ answer addLast: subString ].
						codeStream skip: 1.
					].
				] ifFalse: [
					(codeStream peek) isLetter ifTrue: [
						subString := RtcPortal positionableStream: codeStream selectWhile: [ :chr | 
							chr isLetter or: [(chr == $:) and: [codeStream peek ~= $=]] 
						].
						answer addLast: subString asSymbol.
					] ifFalse: [
						(codeStream peek) isSeparator 
						ifTrue:  [ codeStream skip: 1 ] 
						ifFalse: [
							| addItem |
							addItem := codeStream next.
							addItem isPunctuation ifTrue: [
								| nextTwo found |
								nextTwo := addItem asString, (codeStream atEnd ifFalse: [codeStream peek asString] ifTrue: [' ']).
								found := #(':=' '<=' '>=' '~=' '==' '~~' '//' '>>' '\\' ',,') 
									detect: [:each | each = nextTwo ] ifNone: [ nil ].
								found isNil ifFalse: [ addItem := found. codeStream skip: 1 ].
							].
							answer addLast: addItem asSymbol.
						].
					].
				].
			].
		].
	].
	answer := self findSTSymbolsIn: answer.
	^answer!

test1
	| answer |
	answer := RtcCompiler evaluate: '
			''ABC'', #''DEF'' asString
				 copyFrom: 10 - ''8'' asNumber to:  ''5'' asNumber + 2 - 2; 
				first;
				at: 2 yourself;
				, ''GHI'' yourself; 
				yourself.
	'.
	^answer = 'ABCDEF'! !

!RtcExecutable methodsFor: 'RtcParserComponents'!

asRtcParserExecutable: aParser

	" ^self "

! !

!RtcExecutionData methodsFor: 'RtcParserComponents'!

assignableAtKey: aSymbol

	| ref |
	ref := self 
		atKey: aSymbol 
		ifAbsent: [ ^self error: 'Reference to undeclared variable' ].
	^ref isAssignable
		ifTrue: [ ref ]
		ifFalse: [ self error: 'Unable to assign values to variable' ]
!

literalReferenceFor: aLiteral

	^prefix literalReferenceFor: aLiteral
!

literalReferenceForGlobalNamed: globalKey

	^prefix literalReferenceForGlobalNamed: globalKey
!

methodDataClass

	^prefix methodDataClass
!

referenceFor: aSymbol ifFail: failBlock

	| ref |
	(aSymbol == #nil) ifTrue: [ ^nil ].
	(aSymbol == #true) ifTrue: [ ^true ].
	(aSymbol == #false) ifTrue: [ ^false ].
	(aSymbol == #self) ifTrue: [ ^self instance ].
	(aSymbol == #super) ifTrue: [ ^#super ].
	ref := self atKey: aSymbol ifAbsent: [].
	ref isNil 
	ifFalse: [ ^ref ]
	ifTrue: [
		aSymbol first isUppercase ifFalse: [^failBlock value].
		^self literalReferenceForGlobalNamed: aSymbol.
	].
! !

!RtcMethodData methodsFor: 'As yet unclassified'!

atKey: key ifAbsent: failBlock

	^instVarPool
		detect: [:ref | RtcPortal sequenceableCollection: ref key equals: key ] 
		ifNone: [ self literalReferenceFor: key ifAbsent: failBlock ].!

literalReferenceFor: aLiteral

	^self 
		literalReferenceFor: aLiteral
		ifAbsent: [ 
			(literals addLast: (
				Association
					key: aLiteral
					value: (RtcMethodIndexedVariable indexOffset: literals size + 1)
			)) value
		].
!

literalReferenceFor: aLiteral ifAbsent: failBlock

	^(literals 
		detect: [:litAssoc | litAssoc key equalsLiteral: aLiteral ]
		ifNone: [ ^failBlock value ]
	 ) value.
!

literalReferenceForGlobalNamed: globalKey
	"This method should be fixed so it uses the methodClass."

	| binding aBehavior |
	aBehavior := self methodDataClass.
	globalKey = 'super' ifTrue: [
		(aBehavior respondsTo: #superAssociation)
		ifTrue: [^self superAssociation]	"VA understands"
		ifFalse: [^Association key: 'super' value: aBehavior ].
	].
	binding := RtcPortal
		behavior: self methodDataClass
		bindingFor: globalKey.
	binding isNil ifTrue: [ binding := Association key: globalKey ].
	^self literalReferenceFor: binding!

methodData

	^literals collect: [:literalAssoc | literalAssoc key ]

!

methodDataAt: index

	^(literals at: index) key
!

methodDataClass

	^methodDataClass

!

methodDataClass: aClass

	methodDataClass := aClass.
	literals := OrderedCollection new.
	self setInstVarPool.
!

setInstVarPool

	instVarPool := OrderedCollection new.
	self methodDataClass allInstVarNames do: [:iVarName |
		instVarPool add: (RtcInstanceNamedVariable key: iVarName).
	].
! !

!RtcMethodData class methodsFor: 'As yet unclassified'!

newForClass: aClass

	^self new methodDataClass: aClass


! !

!RtcNamespaceReference methodsFor: 'RtcParserComponents'!

asRtcParserExecutable: aParser

	executable := aParser varPool 
		referenceFor: self key
		ifFail: [ RtcSmalltalkParser parserException signalWith: 'undeclared variable' ].
! !

!RtcSmalltalkParser methodsFor: 'Parse Blocks'!

extractBlockArgumentsIn: anOC

	| args |
	args := OrderedCollection new: 5.
	[ (anOC isEmpty ifTrue: [] ifFalse: [anOC first]) == #':' ] whileTrue: [
		args add: (anOC removeFirst; removeFirst).
	].
	(args size > 0) ifTrue: [
		(anOC first == #'|') ifTrue: [ anOC removeFirst ].
		args := args collect: [:item | RtcArgument key: item ].
	].
	^args
! !

!RtcSmalltalkParser methodsFor: 'Parse Statement'!

extractCascadeBinaryMessageFrom: anOC
	"It can be assumed that the receiver has already been removed."

	| selector argument |
	selector := anOC removeFirst asRtcParserExecutable: self.
	argument := anOC asRtcParserExecutable: self.
	^RtcBinaryMessage
		selector: selector
		argument: argument 

!

extractCascadeKeywordMessageFrom: anOC
	"It can be assumed that the receiver has already been removed."

	| selectorStream argElements args |
	selectorStream := WriteStream on: String new.
	args := OrderedCollection new: 4.
	argElements := nil.		"Only used to avoid VW compiler warning."
	anOC do: [:item |
		item isKeywordMessageSelector 
			ifFalse: [ argElements addLast: item ]
			ifTrue: [ 
				selectorStream nextPutAll: item.
				argElements isNil ifFalse: [ args addLast: (argElements asRtcParserExecutable: self) ].
				argElements := OrderedCollection new.
			].
	].
	args addLast: (argElements asRtcParserExecutable: self).
	^RtcKeywordMessage
		selector: (selectorStream contents asSymbol asRtcParserExecutable: self)
		arguments: args asArray. 

!

extractCascadeMessageFrom: anOC
	"It can be assumed that the receiver has already been removed."

	anOC first isKeywordMessageSelector 
		ifTrue: [ ^self extractCascadeKeywordMessageFrom: anOC ].
	anOC first isBinaryMessageSelector 
		ifTrue: [ ^self extractCascadeBinaryMessageFrom: anOC ].
	^self extractCascadeUnaryMessageFrom: anOC.


!

extractCascadeUnaryMessageFrom: anOC
	"It can be assumed that the receiver has already been removed."

	anOC size = 1 ifFalse: [ self parserException signalWith: '"." expected' ].
	^RtcUnaryMessage selector: (anOC first asRtcParserExecutable: self)

! !

!RtcSmalltalkParser methodsFor: 'Parse Methods'!

extractFirstSelectorAndArgsFrom: anOC

	| selector item args |
	selector := (item := anOC removeFirst) asString.
	args := OrderedCollection new: 4.
	[ item isSymbol and: [item last = $:] ] whileTrue: [
		item := anOC removeFirst.
		args add: item.
		(anOC isEmpty not and: 
		[(item := anOC first) isSymbol and: 
		[item last = $:]]) ifTrue:  [ 
			selector := selector, item.
			anOC removeFirst.
		]
	].
	^Association
		key: selector asSymbol
		value: args asArray! !

!RtcSmalltalkParser methodsFor: 'Parse Statement'!

extractMessageFrom: anOC

	| cascades receiverPart receiver messages msgStart |
	cascades := RtcPortal sequenceableCollection: anOC dividedAt: #';'.
	receiverPart := cascades removeFirst.
	msgStart := receiverPart findFirst: [:item | item isKeywordMessageSelector ].
	msgStart = 0 ifTrue: [ msgStart := receiverPart findLast: [:item | item isBinaryMessageSelector ] ].
	(msgStart = 0 and: [ receiverPart size > 1 ]) ifTrue: [ msgStart := receiverPart size ].
	msgStart = 0 ifFalse: [
		cascades addFirst: (receiverPart copyFrom: msgStart to: receiverPart size).
		receiverPart := receiverPart copyFrom: 1 to: msgStart - 1.
	].
	receiver := self extractReceiverFrom: receiverPart.
	messages := cascades collect: [:subCol | self extractCascadeMessageFrom: subCol ].
	messages isEmpty ifTrue:  [ ^receiver ].
	^receiver == #super 
		ifFalse: [ (RtcDirectedMessage receiver: receiver expressions: messages) simplifiedMessage ]
		ifTrue: [ 
			"VisualAge4.0 introduced binding to 'super' (the method class). Other ST versions
			 may need to use: (self varPool methodDataClass symbol)."
			RtcSuperclassMessage 
				methodClass: (self varPool literalReferenceForGlobalNamed: 'super') 
				expressions: messages 
		].! !

!RtcSmalltalkParser methodsFor: 'Parse Methods'!

extractMethodArgumentsIn: anOC

	| assoc |
	assoc := self extractFirstSelectorAndArgsFrom: anOC.
	assoc value: (
		assoc value collect: [:item | RtcArgument key: item ]
	).
	^assoc
! !

!RtcSmalltalkParser methodsFor: 'Parse Statement'!

extractReceiverFrom: anOC

	| oldFirst initialReceiver |
	anOC isEmpty ifTrue: [self parserException signalWith: 'Receiver expected'].
	initialReceiver := (oldFirst := anOC removeFirst) isSymbol 
		ifFalse: [ oldFirst asRtcParserExecutable: self ]
		ifTrue:  [ self varPool referenceFor: oldFirst ifFail: [ self parserException signalWith: 'Undeclared variable' ]].
	anOC isEmpty ifTrue: [ ^initialReceiver ].
	^anOC 
		addFirst: initialReceiver;
		asRtcParserExecutable: self
!

extractStatementFrom: anOC

	| varName index remainder |
	index := anOC indexOf: #':=' ifAbsent: [].
	index isNil ifTrue: [ ^self extractMessageFrom: anOC ].
	varName := anOC first.
	remainder := anOC copyFrom: index + 1 to: anOC size.
	^RtcVariableAssignment 
		socket: (self varPool assignableAtKey: varName) 
		executable: (remainder asRtcParserExecutable: self).
! !

!RtcSmalltalkParser methodsFor: 'Parse Methods'!

extractStatementsFrom: anOC

	| foundAnExit |
	foundAnExit := false.
	^(RtcPortal sequenceableCollection: anOC dividedAt: #'.') asArray collect: [:subCol | 
		| executable |
		foundAnExit ifTrue: [self parserException signalWith: 'Syntax error -- statements following a method exit.'].
		((subCol isEmpty ifTrue: [] ifFalse: [subCol first]) == #'^') ifTrue: [
			foundAnExit := true.
			subCol removeFirst.
		].
		executable := subCol asRtcParserExecutable: self.
		foundAnExit
			ifFalse: [ executable ]
			ifTrue:  [ RtcMethodExit executable: executable ]
	 ].!

extractTempsIn: anOC

	^((anOC isEmpty ifTrue: [] ifFalse: [anOC first]) == #'|') 
		ifFalse: [ #() ]
		ifTrue: [
			| temps |
			anOC removeFirst.
			temps := RtcPortal 
				orderedCollection: anOC 
				selectWhile: [:item | item isSymbol and: [item ~~ #'|'] ].
			(temps size > 0) ifTrue: [1 to: temps size + 1 do: [:i | anOC removeFirst ]].
			temps collect: [:item | RtcTemporaryVariableReference key: item ]
		].
! !

!RtcSmalltalkParser methodsFor: 'Tokenize'!

findSTSymbolsIn: sourceCollection
	"Iterates over readStream and answer and OrderedCollection representing ST
	 code type items found within readStream."
	| answer readStream |
	readStream := ReadStream on: sourceCollection.
	answer := OrderedCollection new: sourceCollection size.
	[ readStream atEnd ] whileFalse: [
		| item |
		item := readStream next.
		(item == #'#') ifTrue: [
			| nextItem |
			"Note: Doesn't check for read past end."
			nextItem := readStream next.
			item := nextItem = #'(' 
			ifTrue: [ (readStream upTo: #')') asArray ]
			ifFalse: [
				nextItem = #'[' 
				ifTrue: [ (readStream upTo: #']') asByteArray ]
				ifFalse: [ RtcCodedSymbol symbol: (RtcPortal symbolClassIntern: nextItem) ].
			].
		].
		(item == #'##') ifTrue: [
			| nextItem |
			"Note: Doesn't check for read past end."
			nextItem := readStream next.
			item := ( nextItem == #'(' ) 
				ifFalse: [ RtcCodedAtom symbol: (RtcPortal atomClassIntern: nextItem) ]
				ifTrue:  [ RtcCodedCachedExecution tokens: (readStream upTo: #')') ].
		].
		(readStream peek == #'::') ifTrue: [
			item := RtcNamespaceReference 
				namespace: item 
				key: (readStream next; next).
		].
		answer addLast: item.
	].
	^answer! !

!RtcSmalltalkParser methodsFor: 'Parse Methods'!

in: receiver	"anOrderedCollection"
 replaceEachFrom: startParen
 to: endParen
 with: replaceBlock

	| endBracketPos |
	[ (endBracketPos := receiver indexOf: endParen) > 0 ] whileTrue: [
		| startBracketPos |
		startBracketPos := RtcPortal
			sequenceableCollection: receiver 
			lastIndexOf: startParen 
			startingAt: endBracketPos
			ifAbsent: [ 0 ].
		(startBracketPos = 0) 
		ifTrue: [ receiver removeAtIndex: endBracketPos. ]
		ifFalse: [
			receiver at: startBracketPos put: (
				replaceBlock value: (
					receiver copyFrom: startBracketPos + 1 to: endBracketPos - 1
				)
			).
			endBracketPos to: startBracketPos + 1 by: -1 do: [:index |
				receiver removeAtIndex: index.
			].
		].
	].! !

!RtcSmalltalkParser methodsFor: 'Tokenize'!

isNextTokenNumberIn: codeStream

	| peekedChr |
	peekedChr := codeStream peek.
	^peekedChr isDigit 
		or: [ (peekedChr = $-) 
			and: [|tmp| tmp := codeStream next; next. codeStream skip: -2. tmp isDigit] 
		]
! !

!RtcSmalltalkParser methodsFor: 'As yet unclassified'!

literalReferenceFor: anObject

	^self varPool literalReferenceFor: anObject
! !

!RtcSmalltalkParser methodsFor: 'Parse Blocks'!

newBlockFromParserElements: anOC

	| statements arguments temporaries localVarPool |
	arguments := self extractBlockArgumentsIn: anOC.
	temporaries := self extractTempsIn: anOC.
	localVarPool := self varPool addArguments: arguments temporaries: temporaries.
	self useVarPool: localVarPool while: [
		self parseLocalBlocksIn: anOC.
		self rtcParseRoundBracketsFrom: anOC.
		statements := self extractStatementsFrom: anOC.
	].
	^(RtcBlock new)
		argCount: arguments size;
		statements: statements;
		dataSockets: localVarPool
! !

!RtcSmalltalkParser methodsFor: 'Parse Methods'!

newMethodFromParserElements: anOC forClass: aClass

	| varPool statements selectorAndArgs temporaries |
	selectorAndArgs := self extractMethodArgumentsIn: anOC.
	temporaries := self extractTempsIn: anOC.
	varPool := RtcMethodExecutionData
		newForClass: aClass
		arguments: selectorAndArgs value
		temporaries: temporaries.
	self useVarPool: varPool while: [
		self parseLocalBlocksIn: anOC.
		self rtcParseRoundBracketsFrom: anOC.
		statements := self extractStatementsFrom: anOC.
	].
	^(RtcCompiledMethod new: varPool prefix methodData size)
		argCount: selectorAndArgs value size;
		methodClass: aClass;
		selector: selectorAndArgs key;
		statements: statements;
		dataSockets: varPool

! !

!RtcSmalltalkParser methodsFor: 'Tokenize'!

nextSTTokenFrom: codeStream addTo: tokens
	"This is basically a case statement method. Return value isn't important
	 because returns are only use to exit the method/case statement."

	| peekedChr |
	peekedChr := codeStream peek.
	(self isNextTokenNumberIn: codeStream)
		ifTrue: [ ^tokens addLast: (self tokenizeSTNumberIn: codeStream) ].
	peekedChr = $$ 
		ifTrue: [ ^tokens addLast: (codeStream next; next) ].
	peekedChr = $'
		ifTrue: [ ^tokens addLast: (self tokenizeQuotesIn: codeStream) ].
	peekedChr = $"
		ifTrue: [ ^self tokenizeQuotesIn: codeStream ].
	peekedChr isLetter
		ifTrue: [ ^tokens addLast: (self tokenizeWordIn: codeStream) ].
	peekedChr isSeparator
		ifTrue: [ ^codeStream next ].
	peekedChr isBinaryMessageCharacter
		ifTrue: [ ^tokens addLast: (self tokenizeBinaryMessageIn: codeStream) ].
	peekedChr = $: 
		ifTrue: [ ^tokens addLast: (self tokenizeColonIn: codeStream) ].
	peekedChr = $#
		ifTrue: [ ^tokens addLast: (self tokenizePoundSignIn: codeStream) ].
	^tokens addLast: codeStream next asSymbol
! !

!RtcSmalltalkParser methodsFor: 'Parse Blocks'!

parseLocalBlocksIn: anOC

	self 
		replaceOuterIn: anOC
		from: #'['
		to: #']'
		with: [:array | self newBlockFromParserElements: array ].
! !

!RtcSmalltalkParser methodsFor: 'As yet unclassified'!

parserException

	^self class parserException
! !

!RtcSmalltalkParser methodsFor: 'Tokenize'!

parseSTTokensFromString: codeString
	| codeStream tokens |
	codeStream := ReadStream on: codeString.
	tokens := OrderedCollection new.
	[ codeStream atEnd ] whileFalse: [
		self nextSTTokenFrom: codeStream addTo: tokens
	].
	^self findSTSymbolsIn: tokens.
! !

!RtcSmalltalkParser methodsFor: 'Parse Blocks'!

replaceOuterIn: anOC from: startParen to: endParen with: replaceBlock

	| startBracketPos |
	[(startBracketPos := anOC indexOf: startParen) > 0] whileTrue: [
		| depth index | 
		depth := 1.
		index := startBracketPos.
		[ depth > 0 and: [(index := index + 1) <= anOC size]] whileTrue: [
			| item |
			item := anOC at: index.
			(item == startParen) ifTrue: [ depth := depth + 1 ].
			(item == endParen)  ifTrue: [ depth := depth - 1 ].
		].
		(depth = 0) 
		ifFalse: [ ^self error: 'Unbalanced parenthesis' ]
		ifTrue:  [
			anOC removeAtIndex: index.
			anOC at: startBracketPos put: (
				replaceBlock value: (
					anOC removeFrom: startBracketPos + 1 to: index - 1
				)
			).
		].
	].
	^anOC
! !

!RtcSmalltalkParser methodsFor: 'Parse Methods'!

rtcParseRoundBracketsFrom: anOC

	^self 
		in: anOC
		replaceEachFrom: #'('
		to: #')'
		with: [:subCollection | 
			(subCollection size = 1) 
			ifTrue:  [ subCollection at: 1 ]
			ifFalse: [ self rtcParseRoundBracketsFrom: subCollection ]
		].
! !

!RtcSmalltalkParser methodsFor: 'Tokenize'!

tokenizeBinaryMessageIn: codeStream
	"The next character in codeStream was determined to be
	 the first character of a ST binary message selector. Answer a 
	 string containing all binary message selectors that follow. This
	 method complies with the new standard that binary message
	 selectors are no longer limited to two characters."

	| msgStream |
	msgStream := WriteStream on: String new.
	msgStream nextPut: codeStream next.
	[codeStream atEnd not and: [ codeStream peek isBinaryMessageCharacter ]] 
		whileTrue: [ msgStream nextPut: codeStream next ].
	^msgStream contents asSymbol
!

tokenizeColonIn: codeStream

	codeStream next.
	codeStream atEnd ifTrue: [ self parserException signalWith: 'syntax error' ].
	(codeStream peek = $=) ifTrue: [
		codeStream skip: 1.
		^#':='.
	].

	"VisualAge 4.0 introduces namespaces which are identified by
	 the format <application> :: <class>. Note: If there isn't a space
	 after the application then it will be parsed by another method."
	(codeStream peek = $:) ifTrue: [
		codeStream skip: 1.
		^#'::'.
	].

	"This is only be valid for block argument names."
	^#':'

!

tokenizePoundSignIn: codeStream
	"The next character in codeStream was determined to be
	 a pound sign. If two pound signs are next to eachother then
	 treat them as one."

	codeStream next.
	codeStream atEnd ifFalse: [
		codeStream peek = $# ifTrue: [
			codeStream next.
			^#'##'.
		].
	].
	^#'#'
!

tokenizeQuotesIn: codeStream

	| quoteChar subString |
	quoteChar := codeStream next.
	subString := RtcPortal 
		positionableStream: codeStream 
		selectWhile: [:chr | chr ~= quoteChar ].
	codeStream atEnd ifTrue:  [ self parserException signalWith: 'unbalanced quotes' ].
	codeStream skip: 1.
	^subString
!

tokenizeSTNumberIn: codeStream

	| numberString negate value radix |
	(negate := codeStream peek = $-) ifTrue: [ codeStream next ].
	numberString := RtcPortal 
		positionableStream: codeStream 
		selectWhile: [:chr | 
			(chr isDigitForRadix: 10) or: [ 
			(chr = $.) and: [ 
			(codeStream atEnd not) and: [
			codeStream peek isDigit ] ] ] 
		].
	radix := 10.
	(codeStream peek = $r) ifTrue: [
		radix := RtcPortal characterCollection: numberString asNumberRadix: 10.
		codeStream next.
		(negate := codeStream peek = $-) ifTrue: [ codeStream next ].
		numberString := RtcPortal positionableStream: codeStream selectWhile: [:chr | 
			(chr isDigitForRadix: radix) or: [ 
			(chr = $.) and: [ 
			(codeStream atEnd not) and: [
			codeStream peek isDigit ] ] ] 
		].
	].
	value := RtcPortal characterCollection: numberString asNumberRadix: radix.
	(codeStream peek = $e) ifTrue: [
		| exponentString exponent |
		codeStream next.
		exponentString := RtcPortal positionableStream: codeStream selectWhile: [:chr | 
			(chr isDigitForRadix: 10) | (chr = $-)
		].
		exponent := RtcPortal characterCollection: exponentString asNumberRadix: 10.
		value := value * (radix raisedTo: exponent).
	].
	negate ifTrue: [ 
		value := (value = 0) ifTrue: [$-] ifFalse: [value negated].
	].
	^value!

tokenizeWordIn: codeStream
	"Colons are accepted along with letters because the
	 word may be a selector. However, make sure := assignments
	 and :: namespaces are not parsed as selectors."

	| subString |
	subString := RtcPortal positionableStream: codeStream selectWhile: [ :chr | 
		chr isLetter or: [(chr == $:) and: [(#($= $:) includes: codeStream peek) not]] 
	].
	^subString asSymbol.
! !

!RtcSmalltalkParser methodsFor: 'As yet unclassified'!

useVarPool: newVarPool while: aBlock
	"This method is used as an alternative to passing the varPool around.
	 The varPool may change depending on the current context."

	| oldVarPool |
	oldVarPool := activeVarPool.
	activeVarPool := newVarPool.
	aBlock value.
	activeVarPool := oldVarPool.
!

varPool

	^activeVarPool
! !

!RtcSmalltalkParser class methodsFor: 'As yet unclassified'!

parse: string class: aClass errorHandler: errorHandler ifFail: failBlock

	| inst elements |
	inst := self new.
	elements := inst parseSTTokensFromString: string.
	^(inst newMethodFromParserElements: elements forClass: aClass)
		sourceString: string;
		yourself.
!

parserException

	ParserException isNil ifTrue: [ 
		ParserException := RtcPortal exceptionRoot newChild
			description: 'Parser Error';
			yourself.
	 ].
	^ParserException! !

!Symbol methodsFor: 'RtcParserComponents'!

isBinaryMessageSelector
	"Answer whether the receiver should be parsed in ST source code
	 as a binary message to be given priority over keyword messages."

	^self first isBinaryMessageCharacter
!

isKeywordMessageSelector

	^self last = $:! !

!Array methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitArray: self
! !

!Association methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitAssociation: self
! !

!ByteArray methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitByteArray: self
! !

!Object methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitObject: self
! !

!RtcArgument methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitArgument: self
! !

!RtcBinaryMessage methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitBinaryMessage: self
! !

!RtcBlock methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitBlock: self
! !

!RtcCachedExecution methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitCachedExecution: self
! !

!RtcCompiledMethod methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitCompiledMethod: self
! !

!RtcDataConstraint methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitDataConstraint: self
! !

!RtcDirectedBinaryMessage methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitDirectedBinaryMessage: self
! !

!RtcDirectedKeywordMessage methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitDirectedKeywordMessage: self
! !

!RtcDirectedMessage methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitDirectedMessage: self
! !

!RtcDirectedUnaryMessage methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitDirectedUnaryMessage: self
! !

!RtcInstanceNamedVariable methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitInstanceNamedVariable: self
! !

!RtcInstanceReference methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitInstanceReference: self
! !

!RtcKeywordMessage methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitKeywordMessage: self
! !

!RtcMethodExit methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitMethodExit: self
! !

!RtcMethodIndexedVariable methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitMethodIndexedVariable: self
! !

!RtcNamespaceReference methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitNamespaceReference: self
! !

!RtcParentContextIndex methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitParentContextIndex: self
! !

!RtcParseTreeVisitor methodsFor: 'Context'!

blockStack

	^blockStack
!

contextStack

	^contextStack
! !

!RtcParseTreeVisitor methodsFor: 'Child Processing'!

encounteredChild: anObject

	^anObject acceptParseElementVisitor: self.
!

encounteredChildArgument: anObject

	^self encounteredChild: anObject
!

encounteredChildArguments: anArray

	^anArray collect: [:argument | self encounteredChildArgument: argument ]
!

encounteredChildCascades: anArray

	^anArray collect: [:message | self encounteredChildMessage: message ]
!

encounteredChildDataConstraint: anObject

	^self encounteredChild: anObject
!

encounteredChildExecutable: anObject

	^self encounteredChild: anObject
!

encounteredChildMessage: anObject

	^self encounteredChild: anObject
!

encounteredChildMethodData: anObject

	^self encounteredChild: anObject
!

encounteredChildNamespaceName: anObject

	^self encounteredChild: anObject
!

encounteredChildReceiver: anObject

	^self encounteredChild: anObject
!

encounteredChildSelector: anObject

	^self encounteredChild: anObject
!

encounteredChildStatement: anObject

	^self encounteredChild: anObject
!

encounteredChildStatements: anArray

	^anArray collect: [:statement | self encounteredChildStatement: statement ]
!

encounteredChildTemporaries: anArray

	^anArray collect: [:temporary | self encounteredChildTemporary: temporary ]
!

encounteredChildTemporary: anObject

	^self encounteredChild: anObject
! !

!RtcParseTreeVisitor methodsFor: 'As yet unclassified'!

initialize

	contextStack := OrderedCollection new.
	blockStack := OrderedCollection new.

	"messageStack is only set for the context of a  block."
! !

!RtcParseTreeVisitor methodsFor: 'Context'!

messageStack

	^messageStack
!

methodData

	^self blockStack last dataSockets
!

popContext

	^contextStack removeLast.

!

popMessageContext

	self popContext.
	^messageStack removeLast.

!

pushContext: anObject

	contextStack addLast: anObject.

!

pushMessageContext: anObject

	messageStack addLast: anObject.
	self pushContext: anObject.
!

useBlockContext: context while: aBlock

	| answer originalMessageStack |
	blockStack addLast: context.
	self pushContext: context.
	originalMessageStack := messageStack.
	messageStack := OrderedCollection new.
	answer := aBlock value.
	messageStack := originalMessageStack.
	self popContext.
	blockStack removeLast.
	^answer
! !

!RtcParseTreeVisitor methodsFor: 'Visitation'!

visitArgument: anArgument

	self 
		pushContext: anArgument;
		encounteredChildDataConstraint: anArgument dataConstraint;
		popContext.
!

visitArray: anArray

	"Do nothing by default"
!

visitAssociation: anAssociation

	"Do nothing by default"
!

visitBinaryMessage: aBinaryMessage

	self 
		pushMessageContext: aBinaryMessage;
		encounteredChildSelector: aBinaryMessage selector;
		encounteredChildArgument: aBinaryMessage argument;
		popMessageContext.
!

visitBlock: aBlock

	self 	useBlockContext: aBlock while: [
		self 
			encounteredChildArguments: aBlock argumentSockets;
			encounteredChildTemporaries: aBlock temporarySockets;
			encounteredChildStatements: aBlock statements.
	].
!

visitByteArray: aByteArray

	"Do nothing by default"
!

visitCachedExecution: aCachedExecution

	self 
		pushContext: aCachedExecution;
		encounteredChildExecutable: aCachedExecution executable;
		popContext.
!

visitCompiledMethod: aCompiledMethod

	self 	useBlockContext: aCompiledMethod while: [
		self 
			encounteredChildArguments: aCompiledMethod argumentSockets;
			encounteredChildTemporaries: aCompiledMethod temporarySockets;
			encounteredChildStatements: aCompiledMethod statements.
	].
!

visitDataConstraint: aDataConstraint

	"Do nothing by default."
!

visitDirectedBinaryMessage: aDirectedBinaryMessage

	self 
		pushMessageContext: aDirectedBinaryMessage;
		encounteredChildReceiver: aDirectedBinaryMessage receiver;
		encounteredChildSelector: aDirectedBinaryMessage selector;
		encounteredChildArgument: aDirectedBinaryMessage argument;
		popMessageContext.
!

visitDirectedKeywordMessage: aDirectedKeywordMessage

	self 
		pushMessageContext: aDirectedKeywordMessage;
		encounteredChildReceiver: aDirectedKeywordMessage receiver;
		encounteredChildSelector: aDirectedKeywordMessage selector;
		encounteredChildArguments: aDirectedKeywordMessage arguments;
		popMessageContext.!

visitDirectedMessage: aDirectedMessage

	self 
		pushMessageContext: aDirectedMessage;
		encounteredChildReceiver: aDirectedMessage receiver;
		encounteredChildCascades: aDirectedMessage cascades;
		popMessageContext.
!

visitDirectedUnaryMessage: aDirectedUnaryMessage

	self 
		pushMessageContext: aDirectedUnaryMessage;
		encounteredChildReceiver: aDirectedUnaryMessage receiver;
		encounteredChildSelector: aDirectedUnaryMessage selector;
		popMessageContext.
!

visitInstanceNamedVariable: anInstanceNamedVariable

	self 
		pushContext: anInstanceNamedVariable;
		encounteredChildDataConstraint: anInstanceNamedVariable dataConstraint;
		popContext.
!

visitInstanceReference: aInstanceReference

	"Do nothing by default"
!

visitKeywordMessage: aKeywordMessage

	self 
		pushMessageContext: aKeywordMessage;
		encounteredChildSelector: aKeywordMessage selector;
		encounteredChildArguments: aKeywordMessage arguments;
		popMessageContext.
!

visitMethodExit: aMethodExit

	self 
		pushContext: aMethodExit;
		encounteredChildExecutable: aMethodExit executable;
		popContext.
!

visitMethodIndexedVariable: aMethodIndexedVariable

	self 
		pushContext: aMethodIndexedVariable;
		encounteredChildMethodData: (self methodData methodDataAt: aMethodIndexedVariable indexOffset);
		popContext.
!

visitNamespaceReference: aNamespaceReference

	self 
		pushContext: aNamespaceReference;
		encounteredChildNamespaceName: aNamespaceReference namespace;
		encounteredChildExecutable: aNamespaceReference executable;
		popContext.
!

visitObject: anObject

	"Do nothing by default"
!

visitParentContextIndex: aParentContextIndex

	self 
		pushContext: aParentContextIndex;
		encounteredChildMethodData: (self methodData dataAt: aParentContextIndex dataIndex);
		popContext.
!

visitSuperclassMessage: aSuperclassMessage

	self 
		pushMessageContext: aSuperclassMessage;
		encounteredChildReceiver: aSuperclassMessage receiver;
		encounteredChildCascades: aSuperclassMessage cascades;
		popMessageContext.!

visitTemporaryVariableReference: aTemporaryVariableReference

	self 
		pushContext: aTemporaryVariableReference;
		encounteredChildDataConstraint: aTemporaryVariableReference dataConstraint;
		popContext.
!

visitUnaryMessage: anUnaryMessage

	self 
		pushMessageContext: anUnaryMessage;
		encounteredChildSelector: anUnaryMessage selector;
		popMessageContext.
!

visitVariableAssignment: aVariableAssignment

	self 
		pushContext: aVariableAssignment;
		encounteredChildExecutable: aVariableAssignment executable;
		popContext.
! !

!RtcParseTreeVisitor class methodsFor: 'As yet unclassified'!

new

	^self basicNew initialize
! !

!RtcSuperclassMessage methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitSuperclassMessage: self
! !

!RtcTemporaryVariableReference methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitTemporaryVariableReference: self
! !

!RtcUnaryMessage methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitUnaryMessage: self
! !

!RtcVariableAssignment methodsFor: 'RtcParseTreeVisitationSupport'!

acceptParseElementVisitor: visitor
	"Let the visitor know the context of the receiver so that
	 the visitor can do what it needs to do within that context."

	^visitor visitVariableAssignment: self
! !

!RtcPortableBehavior methodsFor: 'Instance creation'!

atomClassIntern: aString
	"Only VA supports Atoms. All other dialects should
	 just use symbols."
	^self symbolClassIntern: aString! !

!RtcPortableBehavior methodsFor: 'Behavior resolution'!

behavior: aBehavior bindingFor: key

	^SrpPortal behavior: aBehavior bindingFor: key!

behavior: aBehavior lookupSelector: selector
	"VA implements #lookupSelector: to answer the
	 compiled method for selector. VW uses #findSelector:
	 and answers an array with the second element as the
	 compiled method."

	^aBehavior lookupSelector: selector! !

!RtcPortableBehavior methodsFor: 'Collection iteration'!

characterCollection: receiver asInteger: radix
	"The receiver must be a valid digit string (0-9, A-Z only).
	 Answer the integer value for the given radix. Answer nil
	 if one of the characters exceeds the radix."

	| result neg digit |
	neg := (receiver at: 1) = $-.
	result := 0.
	(neg ifTrue: [2] ifFalse: [1])
		to: receiver size
		do: [:i |
			result := result * radix.
			(digit := (receiver at: i) digitValue) >= radix
				ifTrue: [^nil].
			result := result + digit
		].
	^neg ifTrue: [result negated] ifFalse: [result]!

characterCollection: receiver asNumberRadix: radix
	"Answer the object conforming to integer or float specified by the
	 receiver. A minus sign is looked for in this method.
	 The format is: [-]123[.456]"

	| subStrings answer negate intPart |
	subStrings := self characterCollection: receiver subStrings: $..
	intPart := subStrings at: 1.
	(negate := intPart first = $-)
		ifTrue: [ intPart := intPart copyFrom: 2 to: intPart size ].
	answer := (1 < subStrings size) 
		ifFalse: [ self characterCollection: intPart asInteger: radix ] 
		ifTrue: [
			| fracPart |
			fracPart := subStrings at: 2.
			(	(	self characterCollection: (intPart , fracPart) asInteger: radix
				) / (radix raisedToInteger: fracPart size)
			) asFloat.
		].
	^negate 
		ifFalse: [answer] 
		ifTrue:  [answer negated].!

characterCollection: receiver subStrings: aCharacter
	"Answer an array which contains the words in the receiver split
	 on occurrences of aCharacter. aCharacter is not included."

	| answer startIndex endIndex |
	startIndex := 1.
	answer := OrderedCollection new.
	[(endIndex := self 
		sequenceableCollection: receiver 
		indexOf: aCharacter 
		startingAt: startIndex
	 ) == 0] whileFalse: [
		answer add: (receiver copyFrom: startIndex to: endIndex - 1).
		startIndex := endIndex + 1].
	^answer 
		add: (receiver copyFrom: startIndex to: receiver size);
		asArray!

characterCollectionAsArrayOfKeywords: receiver
	"Answer an array of substrings from the receiver. The
	 receiver is divided into substrings at the occurrences of
	 : characters."

	| answer index oldIndex selfSize |
	index := 0.
	answer := OrderedCollection new.
	[(index := self 
		sequenceableCollection: receiver 
		indexOf: $: 
		startingAt: (oldIndex := index + 1)
	 ) == 0] whileFalse: [
		answer add: (receiver copyFrom: oldIndex to: index)].
	oldIndex < (selfSize := receiver size) ifTrue: [
		answer add: (receiver copyFrom: oldIndex to: selfSize)].
	^answer asArray! !

!RtcPortableBehavior methodsFor: 'Behavior resolution'!

compiledMethod: receiver executeWithReceiver: rcvr andArguments: args
	"Evaluate the method.  The argument is an Array whose elements are the
	arguments for the method.  Fail if the length of the Array is not the same
	as the the number of arguments that the method was expecting,
	or if rcvr is not an instance of the mclass of the method
	or of some subclass of the mclass."

	^receiver valueWithReceiver: rcvr arguments: args!

compiledMethod: receiver indexOfLiteral: anObject

	1 to: (self compiledMethodLiteralSize: receiver) do: [:index |
		((receiver at: index) equalsLiteral: anObject) ifTrue: [ ^index ].
	].
	^0
!

compiledMethodLiteralSize: receiver

	^receiver size!

compilerForBehavior:  aBehavior
	"VA and Dolphin use #compiler. VW and ST/X use #compilerClass."

	^aBehavior compiler! !

!RtcPortableBehavior methodsFor: 'Message handling'!

exceptionRoot

	^nil! !

!RtcPortableBehavior methodsFor: 'Collection iteration'!

orderedCollection: receiver selectWhile: aBlock

	| answer |
	answer := OrderedCollection new.
	receiver do: [:ea | 
		(aBlock value: ea)
			ifTrue: [ answer add: ea ]
			ifFalse: [ ^answer ].
	].
	^answer!

positionableStream: receiver selectWhile: testBlock

	| beginning end |
	beginning := (end := receiver position) + 1.
	[ receiver atEnd not and: [ testBlock value: receiver next ] ] 
		whileTrue: [ end := end + 1 ].
	^receiver 
		position: end;
		copyFrom: beginning to: end
!

sequenceableCollection: receiver dividedAt: anObject
	"Answer an array which contains the words in the receiver split
	 on occurrences of aCharacter. aCharacter is not included."

	| answer startIndex endIndex |
	startIndex := 1.
	answer := OrderedCollection new.
	[(endIndex := self 
		sequenceableCollection: receiver 
		indexOf: anObject 
		startingAt: startIndex
	 ) = 0] whileFalse: [
		(endIndex - startIndex > 0) ifTrue: [
			answer add: (receiver copyFrom: startIndex to: endIndex - 1).
		].
		startIndex := endIndex + 1].
	(startIndex <= receiver size) ifTrue: [
		answer add: (receiver copyFrom: startIndex to: receiver size).
	].
	^answer!

sequenceableCollection: receiver doWithIndex: aBlock
	"Iteratively evaluate the two argument block, aBlock using
	 each element of the receiver, in order, and the element
	 index. Fail if aBlock is not a two argument block."

	1 to: receiver size do: [:index | aBlock value: (receiver at: index) value: index].

	"VW doesn't support #doWithIndex:. VA does."!

sequenceableCollection: receiver equals: aCollection
	"Answer true if the receiver and aCollection contain the same elements
	 in the same order."

	receiver == aCollection ifTrue: [^true].
	1 to: receiver size do: [ :index |
		(receiver at: index) = (aCollection at: index)
			ifFalse: [^false ]].
	^true

	"VW doesn't support #equals:. VA does."!

sequenceableCollection: receiver from: start to: stop doWithIndex: aBlock
	"Iteratively evaluate the two argument block, aBlock using
	 the elements from start to stop in the reciever and the
	 element index. Fail if aBlock is not a two argument block."

	start to: stop do: [:index | aBlock value: (receiver at: index) value: index].!

sequenceableCollection: receiver indexOf: anElement startingAt: anIndex
	"Answer an Integer which is the first index of within the receiver
	 that is equivalent to the Object anElement.
	 Start the search in the receiver beginning at the Integer anIndex.
	 If the receiver does not contain an element that is equivalent to
	 anElement, answer 0."

	^self 
		sequenceableCollection: receiver 
		indexOf: anElement 
		startingAt: anIndex 
		ifAbsent: [0]!

sequenceableCollection: receiver
 indexOf: anElement
 startingAt: anIndex
 ifAbsent: exceptionBlock

	"Answer an Integer which is the first index of within the receiver
	 that is equivalent to the Object anElement.
	 Start the search in the receiver beginning at the Integer anIndex.
	 If the receiver does not contain an element that is equivalent to
	 anElement, answer the result of evaluating the zero argument block,
	 exceptionBlock. Fail if the receiver does not contain anElement and
	 exceptionBlock is not a zero-argument Block."

	self 
		sequenceableCollection: receiver 
		from: anIndex 
		to: receiver size 
		doWithIndex: [:element :index | element = anElement ifTrue: [^index]].
	^exceptionBlock value
!

sequenceableCollection: receiver
 lastIndexOf: anObject
 startingAt: startPosition
 ifAbsent: aBlock
		"Answer the index position of the last element equal
		 to anObject in the receiver.  If no such element
		 is found, evaluate aBlock (without any arguments)."
	| index |
	index := receiver size.
	startPosition < index ifTrue: [ index := startPosition. ].
	[index > 0]
		whileTrue: [
			(receiver at: index) = anObject
				ifTrue: [^index].
			index := index - 1].
	^aBlock value!

symbolArgumentCount: receiver
	"Answer the expected number of parameters for
	 the method selector represented by the
	 receiver."

	('<>+-=\/@|&%*~,?!!' includes: receiver first) ifTrue: [^1].
	(receiver at: receiver size) == $: ifFalse: [^0].
	^receiver occurrencesOf: $:! !

!RtcPortableBehavior methodsFor: 'Instance creation'!

symbolClassIntern: aString
	^SrpPortal symbolClassIntern: aString! !

!RtcPortableBehavior methodsFor: 'Environmenal awareness'!

vmTypeName
	"Reuse logic defined elsewhere."

	^SrpPortal vmTypeName
! !

!RtcPortableBehavior class methodsFor: 'Behavior selection'!

initialize
	"	self initialize	"

	SrpPortableBehavior initialize.
	self portal.
!

mightApplyForImage
	"Reuse logic defined elsewhere."

	^SrpPortableBehavior mightApplyForImage
!

newCorrectBehavior

	^self selectCorrectBehavior new
	
!

portal
	"Sent during initialization and as an accessor when loading
	 code that may not have been initialized in the proper sequence."

	"	self portal.	"

	| resp |
	resp := Smalltalk at: #RtcPortal ifAbsent: [].
	resp isNil ifTrue: [
		Smalltalk
			at: #RtcPortal
			put: (resp := self newCorrectBehavior).
	].
	^resp!

selectCorrectBehavior

	| candidates |
	candidates := self withAllSubclasses asArray		"Squeak starts with Set"
		select: [:ea | ea mightApplyForImage ].
	candidates isEmpty
		ifTrue: [ ^self ].
	candidates size = 1
		ifTrue: [ ^candidates first ].
	^candidates last.! !

!RtcPortableBehaviorDol methodsFor: 'As yet unclassified'!

compiledMethod: receiver executeWithReceiver: rcvr andArguments: args
	"Evaluate the method.  The argument is an Array whose elements are the
	arguments for the method.  Fail if the length of the Array is not the same
	as the the number of arguments that the method was expecting,
	or if rcvr is not an instance of the mclass of the method
	or of some subclass of the mclass."

	^receiver value: rcvr withArguments: args!

compiledMethodLiteralSize: receiver

	^receiver literalCount! !

!RtcPortableBehaviorDol class methodsFor: 'As yet unclassified'!

mightApplyForImage
	"Reuse logic defined elsewhere."

	^SrpPortableBehaviorDol mightApplyForImage
! !

!RtcPortableBehaviorStx methodsFor: 'Behavior resolution'!

behavior: aBehavior lookupSelector: selector
	"VA implements #lookupSelector: to answer the
	 compiled method for selector. VW uses #findSelector:
	 and answers an array with the second element as the
	 compiled method."

	aBehavior withAllSuperclasses do: [:ea |
		| cm |
		cm := ea compiledMethodAt: selector ifAbsent: [].
		cm isNil ifFalse: [^cm].
	].
	^nil
!

compiledMethod: receiver executeWithReceiver: rcvr andArguments: args
	"Evaluate the method.  The argument is an Array whose elements are the
	arguments for the method.  Fail if the length of the Array is not the same
	as the the number of arguments that the method was expecting,
	or if rcvr is not an instance of the mclass of the method
	or of some subclass of the mclass."

	^receiver valueWithReceiver: rcvr arguments: args!

compiledMethod: receiver indexOfLiteral: anObject
	"ST/X didn't seem to have an #equalsLiteral: method. Using #= is
	 probably OK for current usage, but isn't ideal for general use. Also,
	 ST/X supports two ways of storing literals 1) with the receiver (the standard
	 way); and 2) as a referenced array. This isn't written in a way that will
	 work with #2."

	1 to: (self compiledMethodLiteralSize: receiver) do: [:index |
		((receiver at: index) = anObject) ifTrue: [ ^index ].
	].
	^0!

compilerForBehavior:  aBehavior
	"VA and Dolphin use #compiler. VW and ST/X use #compilerClass."

	^aBehavior compilerClass! !

!RtcPortableBehaviorStx methodsFor: 'Message handling'!

exceptionRoot

	^Object errorSignal! !

!RtcPortableBehaviorStx methodsFor: 'As yet unclassified'!

sequenceableCollection: receiver doWithIndex: aBlock
	"Iteratively evaluate the two argument block, aBlock using
	 each element of the receiver, in order, and the element
	 index. Fail if aBlock is not a two argument block."

	receiver doWithIndex: aBlock.

! !

!RtcPortableBehaviorStx methodsFor: 'Message handling'!

sequenceableCollection: receiver
 indexOf: anElement
 startingAt: anIndex
 ifAbsent: exceptionBlock

	"Answer an Integer which is the first index of within the receiver
	 that is equivalent to the Object anElement.
	 Start the search in the receiver beginning at the Integer anIndex.
	 If the receiver does not contain an element that is equivalent to
	 anElement, answer the result of evaluating the zero argument block,
	 exceptionBlock. Fail if the receiver does not contain anElement and
	 exceptionBlock is not a zero-argument Block."

	^receiver
		indexOf: anElement
		startingAt: anIndex
		ifAbsent: exceptionBlock!

sequenceableCollection: receiver
 lastIndexOf: anObject
 startingAt: startPosition
 ifAbsent: aBlock
		"Answer the index position of the last element equal
		 to anObject in the receiver.  If no such element
		 is found, evaluate aBlock (without any arguments)."

	^receiver
		lastIndexOf: anObject
		startingAt: startPosition
		ifAbsent: aBlock! !

!RtcPortableBehaviorStx class methodsFor: 'As yet unclassified'!

mightApplyForImage
	"Reuse logic defined elsewhere."

	^SrpPortableBehaviorStx mightApplyForImage! !

!RtcPortableBehaviorVa methodsFor: 'Instance creation'!

atomClassIntern: aString
	"Only VA supports Atoms. All other dialects should
	 just use symbols."
	^(Smalltalk at: #EsAtom) intern: aString! !

!RtcPortableBehaviorVa methodsFor: 'Collection iteration'!

characterCollection: receiver subStrings: aCharacter
	"Answer an array which contains the words in the receiver split
	 on occurrences of aCharacter. aCharacter is not included."

	^receiver subStrings: aCharacter
!

characterCollectionAsArrayOfKeywords: receiver
	"Answer an array of substrings from the receiver. The
	 receiver is divided into substrings at the occurrences of
	 : characters."

	^receiver asArrayOfKeywords
! !

!RtcPortableBehaviorVa methodsFor: 'Behavior resolution'!

compiledMethodLiteralSize: receiver

	^receiver literalSize! !

!RtcPortableBehaviorVa methodsFor: 'Message handling'!

exceptionRoot

	^(Smalltalk at: #SystemExceptions) at: #ExAll asPoolKey
! !

!RtcPortableBehaviorVa methodsFor: 'Collection iteration'!

sequenceableCollection: receiver doWithIndex: aBlock
	"Iteratively evaluate the two argument block, aBlock using
	 each element of the receiver, in order, and the element
	 index. Fail if aBlock is not a two argument block."

	receiver doWithIndex: aBlock.

	"VW doesn't support #doWithIndex:. VA does."!

sequenceableCollection: receiver equals: aCollection
	"Answer true if the receiver and aCollection contain the same elements
	 in the same order."

	^receiver equals: aCollection

	"VW doesn't support #equals:. VA does."!

sequenceableCollection: receiver from: start to: stop doWithIndex: aBlock
	"Iteratively evaluate the two argument block, aBlock using
	 the elements from start to stop in the reciever and the
	 element index. Fail if aBlock is not a two argument block."

	^receiver from: start to: stop doWithIndex: aBlock
!

sequenceableCollection: receiver indexOf: anElement startingAt: anIndex
	"Answer an Integer which is the first index of within the receiver
	 that is equivalent to the Object anElement.
	 Start the search in the receiver beginning at the Integer anIndex.
	 If the receiver does not contain an element that is equivalent to
	 anElement, answer 0."

	^receiver 
		indexOf: anElement 
		startingAt: anIndex!

sequenceableCollection: receiver
 indexOf: anElement
 startingAt: anIndex
 ifAbsent: exceptionBlock

	"Answer an Integer which is the first index of within the receiver
	 that is equivalent to the Object anElement.
	 Start the search in the receiver beginning at the Integer anIndex.
	 If the receiver does not contain an element that is equivalent to
	 anElement, answer the result of evaluating the zero argument block,
	 exceptionBlock. Fail if the receiver does not contain anElement and
	 exceptionBlock is not a zero-argument Block."

	^receiver
		indexOf: anElement
		startingAt: anIndex
		ifAbsent: exceptionBlock
!

symbolArgumentCount: receiver
	"Answer the expected number of parameters for
	 the method selector represented by the
	 receiver."

	^receiver argumentCount! !

!RtcPortableBehaviorVa class methodsFor: 'As yet unclassified'!

mightApplyForImage
	"Reuse logic defined elsewhere."

	^SrpPortableBehaviorVa mightApplyForImage
! !

!RtcPortableBehaviorVw methodsFor: 'Behavior resolution'!

behavior: aBehavior lookupSelector: selector
	"VA implements #lookupSelector: to answer the
	 compiled method for selector. VW uses #findSelector:
	 and answers an array with the second element as the
	 compiled method."

	| arrayOrNil |
	arrayOrNil := aBehavior findSelector: selector.
	^arrayOrNil isNil 
		ifTrue: [ nil ]
		ifFalse: [ arrayOrNil at: 2 ]!

compiledMethod: receiver executeWithReceiver: rcvr andArguments: args
	"Evaluate the method.  The argument is an Array whose elements are the
	arguments for the method.  Fail if the length of the Array is not the same
	as the the number of arguments that the method was expecting,
	or if rcvr is not an instance of the mclass of the method
	or of some subclass of the mclass."

	^receiver valueWithReceiver: rcvr arguments: args!

compiledMethodLiteralSize: receiver

	^receiver numLiterals!

compilerForBehavior:  aBehavior
	"VA and Dolphin use #compiler. VW and ST/X use #compilerClass."

	^aBehavior compilerClass! !

!RtcPortableBehaviorVw methodsFor: 'Message handling'!

exceptionRoot

	^Object errorSignal! !

!RtcPortableBehaviorVw class methodsFor: 'As yet unclassified'!

mightApplyForImage
	"Reuse logic defined elsewhere."

	^SrpPortableBehaviorVw mightApplyForImage
! !

!CompiledMethod methodsFor: 'RtcProxyMethodSupportVW'!

asRtcCompiledMethod

	^RtcCompiler
		compile: self sourceString
		inClass: self methodClass
!

asRtcCompiledMethodProxy

	^self asRtcCompiledMethod asRtcCompiledMethodProxy
!

generate
	"This is a VW hack. The receiver was expected to be a parseNode but is
	 instead an actual compiled method. Answer the receiver in a form that
	 can be used as a native compiled method."

	^self asRtcCompiledMethodProxy!

rtcProxyTemplateCopy
	"Answer a shallow copy of the receiver which can
	 be used as a method proxy." 

	| newMethod |
	newMethod := RtcCompiledMethodProxy new: self size.
	1 to: self size do: [:index |
		newMethod at: index put: (self at: index)
	].
	^newMethod
		byteCodes: bytes;
	   	methodClass: self methodClass;
		sourcePointer: self sourcePointer;
		selector: self selector;
		filePointer: self filePointer;
		yourself.
! !

!RtcCompiledMethod methodsFor: 'RtcProxyMethodSupportVW'!

allLiterals
	"Answer a collection of all the literals in the receiver."

	| literals |
	literals := Array new: self literalSize.
	1 to: self literalSize do: [ :index |
	   literals at: index put: (self at: index)].
	^literals!

allLiteralsDo: aBlock
	"Evaluate aBlock with each literal in the receiver"

	1 to: self literalSize do: [ :index |
	   aBlock value: (self at: index)].
!

application

	^nil

!

asRtcCompiledMethodProxy

	^RtcCompiledMethodProxy proxyForMethod: self
!

equalsLiteral: literal

	^(literal == #RuntimeCompiledMethod) or: 
	 [ super equalsLiteral: literal ]

!

filePointer

	^EmLibraryPointer void!

filePointer: libPointer
	"Ignore any attempts to set a library pointer."

!

generate
	"This is a VW hack. The receiver was expected to be a parseNode but is
	 instead an actual compiled method. Answer the receiver in a form that
	 can be used as a native compiled method."

	^self asRtcCompiledMethodProxy!

literalSize
	"Answer the receiver's number of literals."

	^self size!

referencesLiteral: anObject
	"Answer whether the receiver references anObject. anObject can be:
		- a literal (eg. 'a string', #xx, 1902983039 etc.)
		- the name of a global, class or shared variable
		- the value of a global, class or shared variable
		- an element of a literal array ***
		- a selector sent by the receiver.

	anObject cannot be a temporary or block variable.

	*** Note: arrays will be scanned to see if they include anObject."

	1 to: self literalSize do: [:index |
		((self at: index) equalsLiteral: anObject) ifTrue: [^true]].
	^false!

sendsSelector: aSelector
	"Answer whether the receiver sends aSelector."

	1 to: self literalSize do: [ :index |  
		(self at: index) == aSelector ifTrue: [^true]].
	^false!

testVisibilityIn: potentialApplication

	"Report any references to classes which the potentialApplication cannot see."

	self allLiteralsDo: [:literal |
		literal class == Association ifTrue: [
			(literal value isKindOf: Class) ifTrue: [
				literal value name = literal key ifTrue: [
					(potentialApplication isClassVisible: literal value) ifFalse: [
						"%1 should not reference %2"
						EmImageSupport errorReporter
							logError: 49
							withParms: (Array with: selector printString with: literal value name)]]]]]!

timeStamp
	"Just return the current time for now."

	^EmTimeStamp now
! !

!RtcCompiledMethodProxy methodsFor: 'comparing'!

= aCompiledMethod
	"Answer whether the receiver and
	 aCompiledMethod are the same object."

	^(super = aCompiledMethod) or: 
	 [ self runtimeCompiledMethod = aCompiledMethod ]! !

!RtcCompiledMethodProxy methodsFor: 'accessing-literals'!

allLiterals
	"Answer a collection of all the literals in the receiver."

	^(super allLiterals), (self runtimeCompiledMethod allLiterals)


!

allLiteralsDo: aBlock
	"Evaluate aBlock with each literal in the receiver"

	super allLiteralsDo: aBlock.
	self runtimeCompiledMethod allLiteralsDo: aBlock.
! !

!RtcCompiledMethodProxy methodsFor: 'EM-Internal'!

application
		"Return the application which controls the receiver."

	^self runtimeCompiledMethod application

!

application: anApp
		"Private - Set the application which controls the receiver."

	self halt: 'Notice: Attempt to set a proxy method application.'! !

!RtcCompiledMethodProxy methodsFor: 'copying'!

asRtcCompiledMethodProxy
	"Answer the receiver."

	" ^self "! !

!RtcCompiledMethodProxy methodsFor: 'EM-Internal'!

deleteObjectNamed: aName
	"Delete the object named aName from the receiver."

	self error: 'Attempt to access library for a method proxy'
!

description
		"Return the description for the receiver."

	^'Proxy method'!

filePointer

	^EmLibraryPointer void
!

filePointer: libPointer
	"Ignore any attempts to set a library pointer."

!

loadPrevious
		"If the receiver has a previous edition - load it if it still exists in
		 the library and return true otherwise return false."

	^false!

objectNamed: aName ifAbsent: aBlock
		"Return the object in the library which is known to the
		 receiver as a user field named aName. If the object is
		 not found, return the result of evaluating aBlock."

	^self error: 'Attempt to access object associated with a method proxy.'
! !

!RtcCompiledMethodProxy methodsFor: 'accessing-literals'!

rcmIndex

	^RtcPortal compiledMethod: self indexOfLiteral: #RuntimeCompiledMethod! !

!RtcCompiledMethodProxy methodsFor: 'EM-Internal'!

record
	"Private - Return the receiver's record."

	"self halt: 'Attempt to access library record for a method proxy.'."

	^EmMethodEdition empty!

referencesLiteral: anObject
	"Answer whether the receiver references anObject. anObject can be:
		- a literal (eg. 'a string', #xx, 1902983039 etc.)
		- the name of a global, class or shared variable
		- the value of a global, class or shared variable
		- an element of a literal array ***
		- a selector sent by the receiver.
	anObject cannot be a temporary or block variable.
	*** Note: arrays will be scanned to see if they include anObject."

	^(super referencesLiteral: anObject) or: 
	 [self runtimeCompiledMethod referencesLiteral: anObject ]
! !

!RtcCompiledMethodProxy methodsFor: 'accessing-literals'!

runtimeCompiledMethod

	^self at: self rcmIndex

!

runtimeCompiledMethod: aRCM

	self 
		at: self rcmIndex
		put: aRCM.

!

sendsSelector: aSelector
	"Answer whether the receiver sends aSelector."

	^(super sendsSelector: aSelector) or: 
	 [ self runtimeCompiledMethod sendsSelector: aSelector ]



! !

!RtcCompiledMethodProxy methodsFor: 'EM-Internal'!

sourceString

	^self runtimeCompiledMethod sourceString!

statusBits
		"Private - Return a byte containing the status bits for the method."

	^2r00000000
!

statusBits: aByte
		"Private - Set the status bits for the receiver.
		 Currently, they consist of only the top 2 bits of aByte."

	  "they are only the top 2 bits in the most significant byte
	   of the filePointer"

	"self halt: 'Attempt to set statusBits for a method proxy.'"

	"Ignore for now"
!

storeObject: anObject as: aName
		"Associate a dumped representation of anObject with the
		 receiver (in the library) using aName. Answer nil if
		 an error occurs. Otherwise answer the receiver."

	^self error: 'Attempt to store anObject along with a method proxy.'
! !

!RtcCompiledMethodProxy methodsFor: 'accessing-literals'!

symbolLiterals
	"Answer all the receiver's literals which are symbols."

	"Method is just like superclass but is overridden to
	 avoid primitive in superclass."

	| result |
	result := OrderedCollection new.
	self allLiteralsDo: [:lit |
		lit isSymbol ifTrue: [
			result add: lit]].
	^result
! !

!RtcCompiledMethodProxy methodsFor: 'EM-Internal'!

testVisibilityIn: potentialApplication
	"Report any references to classes which the potentialApplication cannot see."

	super testVisibilityIn: potentialApplication.
	self runtimeCompiledMethod testVisibilityIn: potentialApplication.



!

timeStamp

	^self runtimeCompiledMethod timeStamp

!

updateRecordWith: transactionBlock
		"Private - Perform the transaction on the receiver's record."

	^self error: 'Attempt to update library for a method proxy.'
! !

!RtcCompiledMethodProxy class methodsFor: 'class initialization'!

initializeProxyMethodTemplates

	"  self initializeProxyMethodTemplates.  "

	ProxyMethodTemplates := Array new: 10.
	1 to: 10 do: [:index |
		| aProxyCM sourceString |
		sourceString := self proxyCodeStringForArgCount: index - 1.
		aProxyCM := (RtcPortal compilerForBehavior: self)
			compileClass: UndefinedObject
			selector: (self proxySelectorForArgCount: index - 1)
			source: sourceString.
		ProxyMethodTemplates
			at: index
			put: aProxyCM
	].! !

!RtcCompiledMethodProxy class methodsFor: 'instance creation'!

proxyCodeStringForArgCount: argCount

	| aStream |
	aStream := WriteStream on: (String new: 400).
	aStream nextPutAll: 'proxy'.
	1 to: argCount do: [:index |
		aStream nextPut: (index = 1 ifTrue: [$W] ifFalse: [$w]).
		aStream nextPutAll: 'ith: proxyArg'.
		index printOn: aStream.
		aStream nextPut: $ .
	].
	aStream 
		cr; cr; tab; nextPutAll: '^(#RuntimeCompiledMethod) ';
		cr; tab; tab; nextPutAll: 'executeWithReceiver: self';
		cr; tab; tab; nextPutAll: 'andArguments: (';
		cr; tab; tab; tab; nextPutAll: '(Array new: '.
		argCount printOn: aStream.
		aStream nextPut: $).
	1 to: argCount do: [:index |
		aStream cr; tab; tab; tab; tab; nextPutAll: 'at: '.
		index printOn: aStream.
		aStream nextPutAll: ' put: proxyArg'.
		index printOn: aStream.
		aStream nextPut: $;.
	].
	aStream 
		cr; tab; tab; tab; tab; nextPutAll: 'yourself';
		cr; tab; tab; nextPutAll: ')'; cr; cr.
	^aStream contents
	! !

!RtcCompiledMethodProxy class methodsFor: 'class initialization'!

proxyForMethod: aCM

	| proxyTemplate |
	proxyTemplate := self 
		proxyTemplateForArgCount: (RtcPortal symbolArgumentCount: aCM).
	^(proxyTemplate rtcProxyTemplateCopy)
		methodClass: aCM methodClass;
		selector: aCM selector;
		runtimeCompiledMethod: aCM;
		yourself.! !

!RtcCompiledMethodProxy class methodsFor: 'instance creation'!

proxySelectorForArgCount: argCount

	| aStream |
	aStream := WriteStream on: String new.
	aStream nextPutAll: 'proxy'.
	1 to: argCount do: [:index |
		aStream nextPut: (index = 1 ifTrue: [$W] ifFalse: [$w]).
		aStream nextPutAll: 'ith:'.
	].
	^aStream contents asSymbol
!

proxyTemplateForArgCount: argCount

	^self rtcProxyMethodTemplates 
		at: argCount + 1
		
! !

!RtcCompiledMethodProxy class methodsFor: 'class initialization'!

rtcProxyMethodTemplates

	^ProxyMethodTemplates

! !

!RtcParagraphEditor methodsFor: 'private'!

evaluateSelection
	"Evaluate the current text selection as an expression"

	| result |
	result := Cursor execute showWhile:
		[RtcCompiler
			evaluate: self selection
			for: self doItReceiver
			ifFail: [:error | self class compilationErrorSignal raise]].
	self doItValue: result.
	SourceFileManager default logChange: self selection string.
	^result! !

!RtcProxyCompiler methodsFor: 'As yet unclassified'!

compile: textOrStream in: aClass notifying: aRequestor ifFail: failBlock 
	"Answer with a parse tree whose root is a MethodNode.
	This can then be told to generate code as is done in the calls from Behavior"

	^self class
		compile: textOrStream
		inClass: aClass
		ifFail: [ :err | failBlock value ].
!

evaluate: textOrStream in: aContext receiver: receiver notifying: aRequestor ifFail: failBlock 
	"Compiles the sourceStream into a parse tree, then generates code 
	into a method.  If receiver is not nil, then the text can refer to
	instance variables of that receiver (the Inspector uses this).  If 
	aContext is not nil, the text can refer to temporaries in that context
	(the Debugger uses this).  If aRequestor is not nil, then it will
	receive a notify:at: message before the attempt to evaluate is aborted. 
	
	Finally, the compiled method is invoked and the value returned"

	^self class
		evaluate: textOrStream
		for: receiver
		ifFail: [ :err | failBlock value ].
!

evaluate: textOrStream in: aContext to: receiver notifying: aRequestor ifFail: failBlock 
	"This is an old message that mixes user interaction with 
	functional behavior. New applications should consider using 
	evaluate:in:receiver:notifying:ifFail:."

	^Cursor execute showWhile:
		[self
			evaluate: textOrStream
			in: aContext
			receiver: receiver
			notifying: aRequestor
			ifFail: failBlock]!

format: textOrStream in: aClass notifying: aRequestor
	"Compile a parse tree from the incoming text, and then print the
	parse tree to yield the answer, a string containing the original code
	in standard format."

	| method |
	method := self class
		compile: textOrStream
		inClass: aClass
		ifFail: [ :err | ^nil ].
	^method sourceString! !

!RtcProxyCompiler class methodsFor: 'As yet unclassified'!

actualCompiler

	^RtcCompiler
!

compile: string inClass: aClass

	^self 
		compile: string 
		inClass: aClass
		ifFail: [:error| ]
!

compile: string inClass: aClass ifFail: failBlock

	| newMethod |
	newMethod := self actualCompiler
		compile: string inClass: aClass ifFail: failBlock.
	^newMethod asRtcCompiledMethodProxy!

evaluate: string
	"Compile and execute string. Answer false if 
	 compile error."

	^self 
		evaluate: string 
		for: nil
		ifFail: [:error| ^false ]
!

evaluate: string for: receiver

	^self 
		evaluate: string 
		for: receiver 
		ifFail: [:error| ]
!

evaluate: string for: receiver ifFail: failBlock

	| method |
	method := self 
		compile: ('Doit
', string) 
		inClass: receiver class 
		ifFail: failBlock.
	^RtcPortal 
		compiledMethod: method 
		executeWithReceiver: receiver
		andArguments: #()! !

!RtcWorkspace methodsFor: 'controller access'!

defaultControllerClass
	"Answer the default controller class for the receiver."

	^RtcParagraphEditor! !

!RtcWorkspace class methodsFor: 'instance creation'!

open
	"Create a scheduled view of a workspace on the screen."

	self
		open: ValueHolder newString
		label: 'RtcWorkspace'! !

!Array methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData

	aStream nextPut: $#.
	super printJavaOn: aStream context: execData.

!

printSTOn: aStream context: execData

	aStream nextPutAll: '#('.
	1 to: self size - 1 do: [:index |
		(self at: index) printSTOn: aStream context: execData.
		aStream space.
	].
	self isEmpty ifFalse: [ (self at: self size) printSTOn: aStream context: execData ].
	aStream nextPut: $).
! !

!Association methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData

	self key isString
	ifTrue:  [ aStream nextPutAll: self key ]
	ifFalse: [ self key printOn: aStream ]
!

printSTOn: aStream context: execData

	self key isString
	ifTrue:  [ aStream nextPutAll: self key ]
	ifFalse: [ self key printOn: aStream ]
! !

!ByteArray methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData

	aStream nextPut: $#.
	super printJavaOn: aStream context: execData.

!

printSTOn: aStream context: execData

	aStream nextPut: $#.
	super printSTOn: aStream context: execData.

! !

!Character methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData

	aStream nextPut: $'.
	self printJavaTokenOn: aStream.
	aStream nextPut: $'.
!

printJavaTokenOn: aStream

	self = $" ifTrue: [ ^aStream nextPutAll: '\"' ].
	self = $' ifTrue: [ ^aStream nextPutAll: '\''' ].
	self = $\ ifTrue: [ ^aStream nextPutAll: '\\' ].
	self asInteger = 8 ifTrue: [ ^aStream nextPutAll: '\b' ].	"VA alias Bs"
	self asInteger = 9 ifTrue: [ ^aStream nextPutAll: '\t' ].		"VA alias Tab"
	self asInteger = 10 ifTrue: [ ^aStream nextPutAll: '\n' ].	"VA alias Lf"
	self asInteger = 13 ifTrue: [ ^aStream nextPutAll: '\r' ].	"VA alias Cr"
	^aStream nextPut: self
!

printSTOn: aStream context: execData

	aStream nextPut: $$.
	aStream nextPut: self.! !

!Object methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData

	self printOn: aStream
!

printJavaWithParenthesisOn: aStream context: execData

	self printOn: aStream!

printSTOn: aStream context: execData

	self printOn: aStream
!

printSTWithParenthesisOn: aStream context: execData

	self printOn: aStream! !

!RtcBinaryMessage methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	| stSelector |
	stSelector := selector rtcPerformUsing: execData.
	stSelector = #'|' ifTrue: [ ^self printJavaSelector: #'||' on: aStream context: execData receiver: receiver ].
	stSelector = #'&' ifTrue: [ ^self printJavaSelector: #'&&' on: aStream context: execData receiver: receiver ].
	stSelector = #',' ifTrue: [ ^self printJavaSelector: #'+' on: aStream context: execData receiver: receiver ].
	stSelector = #'~=' ifTrue: [ ^self printJavaSelector: #'!!=' on: aStream context: execData receiver: receiver ].
	stSelector = #'~~' ifTrue: [ ^self printJavaSelector: #'!!==' on: aStream context: execData receiver: receiver ].
	stSelector = #'\\' ifTrue: [ ^self printJavaSelector: #'%' on: aStream context: execData receiver: receiver ].
	^self printJavaSelector: stSelector on: aStream context: execData receiver: receiver.
!

printJavaSelector: javaSelector on: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	receiver 
		printJavaWithParenthesisOn: aStream 
		context: execData.
	aStream 
		space;
		nextPutAll: javaSelector;
		space.
	argument 
		printJavaWithParenthesisOn: aStream
		context: execData. 
!

printSTOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."


	aStream nextPutAll: (selector rtcPerformUsing: execData).
	aStream space.
	argument 
		printSTWithParenthesisOn: aStream
		context: execData. 
!

showJavaParenthesis

	^true!

showSTParenthesis

	^true! !

!RtcBlock methodsFor: 'RtcScriptSupport'!

debugPrintOn: aStream

	| tempStream |
	tempStream := RtcIndentedWriteStream on: String new.
	self 
		printSTOn: tempStream
		context: dataSockets.
	aStream nextPutAll: tempStream contents.
!

printJavaArgumentsOn: aStream

	aStream nextPut: $(.
	RtcPortal 
		sequenceableCollection: self argumentSockets 
		doWithIndex: [:arg :index |
			aStream nextPutAll: 'Object '.
			arg printJavaOn: aStream context: dataSockets.
			index < self argCount ifTrue: [ aStream nextPutAll: ', ' ].
		].
	aStream nextPut: $).!

printJavaBlockOn: aStream context: parentExecData

	| single |
	single := self statements size = 1. 
	single := single and: [ self argCount = 0 ].
	single := single and: [ self tempCount = 0 ].

	single ifFalse: [ aStream nextPutAll: '{' ].
	self printJavaContentsOn: aStream context: parentExecData.
	single ifFalse: [ aStream nextPutAll: '}' ].


!

printJavaBlockWithoutArgsOn: aStream context: parentExecData

	| single |
	single := self statements size = 1. 
	single := single and: [ self tempCount = 0 ].

	single ifFalse: [ aStream nextPutAll: '{' ].
	self printJavaContentsWithoutArgsOn: aStream context: parentExecData.
	single ifFalse: [ aStream nextPutAll: '}' ].


!

printJavaContentsOn: aStream context: parentExecData

	| subStream indented |
	aStream pushIndentLevel.
	subStream := (RtcIndentedWriteStream on: String new)
		indentLevelCount: aStream indentLevelCount;
		yourself.
	self printJavaTemporariesOn: subStream.
	self printJavaStatementsOn: subStream.
	indented := (subStream contents size > 30) or: [subStream includesCr].
	indented ifTrue: [ aStream cr ].
	aStream
		nextPutAll: subStream contents; 
		popIndentLevel.
	indented ifTrue: [ aStream cr ].

!

printJavaContentsWithoutArgsOn: aStream context: parentExecData

	| subStream indented |
	aStream pushIndentLevel.
	"self printJavaArgumentsOn: aStream."
	subStream := (RtcIndentedWriteStream on: String new)
		indentLevelCount: aStream indentLevelCount;
		yourself.
	self printJavaTemporariesOn: subStream.
	self printJavaStatementsOn: subStream.
	indented := (subStream contents size > 30) or: [subStream includesCr].
	indented ifTrue: [ aStream cr ].
	aStream
		nextPutAll: subStream contents; 
		popIndentLevel.
	indented ifTrue: [ aStream cr ].


!

printJavaOn: aStream context: parentExecData

	| jSel |
	jSel := #('value' 'value_value' 'value_value_value' 'value_value_value_value' 'valueWithArguments')
		at: ((self argCount min: 5) max: 1).
	aStream 
		pushIndentLevel; cr;
		nextPutAll: 'new ExecutionContextTemplate() {';
		pushIndentLevel; cr;
		nextPutAll: 'public Object';
		space;
		nextPutAll: jSel.
	self printJavaArgumentsOn: aStream.
	aStream nextPutAll: ' {'.
	self printJavaContentsOn: aStream context: parentExecData.
	aStream 
		popIndentLevel; nextPutAll: '}'; cr; 
		popIndentLevel; nextPutAll: '}'; cr.!

printJavaStatementsOn: aStream

	statements size > 0 ifTrue: [
		RtcPortal sequenceableCollection: statements doWithIndex: [:exec :index |
			exec printJavaOn: aStream context: dataSockets.
			(index < statements size) ifTrue: [ aStream nextPut: $;; cr ].
		].
	].!

printJavaTemporariesOn: aStream

	| tempSocks |
	tempSocks := self temporarySockets asArray.
	tempSocks size > 0 ifTrue: [
		aStream nextPutAll: 'Object '.
		RtcPortal 
			sequenceableCollection: self temporarySockets 
			doWithIndex: [:socket :index |
				socket printJavaOn: aStream context: dataSockets.
				(index = tempSocks size)
					ifTrue:  [ aStream nextPut: $;; cr ]
					ifFalse: [ aStream nextPutAll: ',  ' ].
			].
	].!

printSTArgumentsOn: aStream

	self argumentSockets size > 0 ifTrue: [
		self argumentSockets do: [:arg |
			aStream nextPut: $:.
			arg printSTOn: aStream context: dataSockets.
			aStream nextPut: $ .
		].
		aStream nextPutAll: '| '.
	].


!

printSTOn: aStream context: parentExecData

	| subStream indented |
	aStream nextPutAll: '['.
	aStream pushIndentLevel.
	self printSTArgumentsOn: aStream.
	subStream := (RtcIndentedWriteStream on: String new)
		indentLevelCount: aStream indentLevelCount;
		yourself.
	self printSTTemporariesOn: subStream.
	self printSTStatementsOn: subStream.
	indented := (subStream contents size > 30) or: [subStream includesCr].
	indented ifTrue: [ aStream cr ].
	aStream
		nextPutAll: subStream contents; 
		popIndentLevel.
	indented ifTrue: [ aStream cr ].
	aStream nextPutAll: ']'.


!

printSTStatementsOn: aStream

	statements size > 0 ifTrue: [
		RtcPortal sequenceableCollection: statements doWithIndex: [:exec :index |
			exec printSTOn: aStream context: dataSockets.
			(index < statements size) ifTrue: [ aStream nextPut: $.; cr ].
		].
	].!

printSTTemporariesOn: aStream

	self temporarySockets size > 0 ifTrue: [
		aStream nextPutAll: '| '.
		self temporarySockets do: [:socket |
			socket printSTOn: aStream context: dataSockets.
			aStream nextPut: $ .
		].
		aStream nextPutAll: '| '.
		aStream cr.
	].


!

showJavaParenthesis

	^true! !

!RtcCachedExecution methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData
	"It has not yet been determined if Java will allow
	 multiple statements to execute within parenthesis."

	aStream nextPut: $(.
	executable 
		printJavaOn: aStream 
		context: execData.
	aStream nextPut: $).
!

printSTOn: aStream context: execData

	aStream nextPutAll: '##('.
	executable 
		printSTOn: aStream 
		context: execData.
	aStream nextPutAll: ')'.
! !

!RtcCompiledMethod methodsFor: 'RtcScriptSupport'!

debugPrintOn: aStream
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	self printOn: aStream.
	aStream cr.
	aStream nextPutAll: self sourceString.

!

javaSource

	"^source"

	| wStream |
	wStream := RtcIndentedWriteStream on: String new.
	self 
		printJavaOn: wStream
		context: dataSockets.
	^wStream contents
!

printJavaOn: aStream context: ignoredExecData

	| aSymbol |
	aStream pushIndentLevel.
	self isPublic
		ifTrue: [ aStream nextPutAll: 'public ' ]
		ifFalse: [ aStream nextPutAll: 'public ' ].
	(aSymbol := self returnType) = #self
		ifTrue: [ aStream nextPutAll: 'void' ]
		ifFalse: [ aStream nextPutAll: aSymbol ].
	aStream space.
	self printJavaSelectorWithArgumentsOn: aStream.
	aStream space; nextPut: ${; cr.
	self printJavaTemporariesOn: aStream.
	self printJavaStatementsOn: aStream.
	aStream 
		popIndentLevel; cr;
		nextPut: $}; cr.

	

!

printJavaSelectorWithArgumentsOn: aStream
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."


	aStream 
		nextPutAll: selector asJavaSelector;
		nextPut: $(.
	1 to: self argCount do: [:i |
		aStream nextPutAll: 'Object '.
		(self argumentSockets at: i) 
			printJavaOn: aStream 
			context: dataSockets.
		(i < self argCount) ifTrue: [ aStream nextPutAll: ', ' ].
	].
	aStream nextPut: $).!

printSTOn: aStream context: ignoredExecData

	aStream pushIndentLevel.
	self printSTSelectorWithArgumentsOn: aStream.
	aStream cr; cr.
	self printSTTemporariesOn: aStream.
	self printSTStatementsOn: aStream.
	aStream popIndentLevel.


!

printSTSelectorWithArgumentsOn: aStream
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	| keywords argCnt |
	keywords := RtcPortal characterCollectionAsArrayOfKeywords: selector.
	argCnt := RtcPortal symbolArgumentCount: selector.
	1 to: keywords size do: [:i |
		aStream nextPutAll: (keywords at: i).
		(argCnt > 0) ifTrue: [
			aStream space.
			(self argumentSockets at: i) 
				printSTOn: aStream 
				context: dataSockets.
			(i < argCnt) ifTrue: [aStream space].
		].
	].!

sourceString

	"^source"

	| wStream |
	wStream := RtcIndentedWriteStream on: String new.
	self 
		printSTOn: wStream
		context: dataSockets.
	^wStream contents
! !

!RtcDirectedBinaryMessage methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	self 
		printJavaOn: aStream 
		context: execData
		receiver: self receiver.
!

printSTOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	self receiver 
		printSTWithParenthesisOn: aStream 
		context: execData.
	aStream space.
	super
		printSTOn: aStream 
		context: execData.
! !

!RtcDirectedKeywordMessage methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	self 
		printJavaOn: aStream 
		context: execData
		receiver: self receiver.
!

printSTOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	self receiver 
		printSTWithParenthesisOn: aStream 
		context: execData.
	aStream space.
	super
		printSTOn: aStream 
		context: execData.
! !

!RtcDirectedMessage methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	"It has not yet been determined if Java will support the
	 execution of multiple statements within parenthesis. This may
	 not work. The last cascade must return a value for the receiver."

	self size > 1 ifTrue: [ aStream nextPut: $( ].
	self cascadesDoWithIndex: [:anExpression :index |
		anExpression 
			printJavaOn: aStream 
			context: execData
			receiver: self receiver.
		index < self size ifTrue: [ aStream nextPut: $;; space ].
	].
	self size > 1 ifTrue: [ aStream nextPut: $) ].
!

printSTOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	self receiver 
		printSTWithParenthesisOn: aStream 
		context: execData.
	self cascadesDoWithIndex: [:anExpression :index |
		(self size > 1) 
			ifTrue:  [ aStream cr; tab ]
			ifFalse: [ aStream space ].
		anExpression 
			printSTOn: aStream 
			context: execData.
		index < self size 
			ifTrue: [ aStream nextPut: $; ].
	].
! !

!RtcDirectedUnaryMessage methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	self 
		printJavaOn: aStream 
		context: execData
		receiver: self receiver.
!

printSTOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	self receiver 
		printSTWithParenthesisOn: aStream 
		context: execData.
	aStream space.
	super
		printSTOn: aStream 
		context: execData.
! !

!RtcExecutable methodsFor: 'RtcScriptSupport'!

printJavaWithParenthesisOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	self showJavaParenthesis
	ifFalse: [ self printJavaOn: aStream context: execData ]
	ifTrue:  [
		aStream nextPut: $(.
		self printJavaOn: aStream context: execData.
		aStream nextPut: $).
	].
!

printSTWithParenthesisOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	self showSTParenthesis
	ifFalse: [ self printSTOn: aStream context: execData ]
	ifTrue:  [
		aStream nextPut: $(.
		self printSTOn: aStream context: execData.
		aStream nextPut: $).
	].
!

showJavaParenthesis

	^false!

showSTParenthesis

	^false! !

!RtcIndentedWriteStream methodsFor: 'As yet unclassified'!

cr

	"Store the cr (carriage return) character as the next object in the
	 receiver.  Answer self.  Set the receiver's position reference to
	 be immediately after the cr character."

	super cr.
	self indentLevelCount timesRepeat: [ self nextPutAll: self indentString ].
!

includesCr

	^self contents includes: (Character value: 13)
!

indentLevelCount

	indentLevelCount isNil ifTrue: [^0].
	^indentLevelCount

!

indentLevelCount: anInteger

	indentLevelCount := anInteger

!

indentString
	"Answer a string containing characters to be used
	 for each indent. By default the string contains a
	 Tab character."

	^'	'
!

popIndentLevel

	"The receiver has been asked to remove the last
	 tab character at the end of its line delimiter."

	self indentLevelCount: (self indentLevelCount - 1 max: 0)!

pushIndentLevel

	"The receiver has been asked to add a tab
	 character to the end of its line delimiter."

	self indentLevelCount: self indentLevelCount + 1
! !

!RtcInstanceReference methodsFor: 'RtcScriptSupport'!

javaKey

	^#this! !

!RtcKeywordMessage methodsFor: 'RtcScriptSupport'!

printJavaAndOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	| aBlock |
	aBlock := self arguments at: 1.
	aBlock statements size > 1 
		ifTrue: [ ^self printJavaNormalOn: aStream context: execData receiver: receiver ].
	receiver 
		printJavaWithParenthesisOn: aStream 
		context: execData.
	aStream nextPutAll: ' && '.
	"Note: This can print more () than necessary."
	aStream nextPut: $(.
	aBlock
		printJavaBlockOn: aStream
		context: execData. 
	aStream nextPut: $).
!

printJavaIfFalseIfTrueOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	| msgArgs |
	msgArgs := self arguments. 
	aStream nextPutAll: 'if ('. 
	receiver 
		printJavaOn: aStream 
		context: execData.
	aStream nextPutAll: ') '.
	(msgArgs at: 2)
		printJavaBlockOn: aStream
		context: execData. 
	aStream nextPutAll: ' else '.
	(msgArgs at: 1)
		printJavaBlockOn: aStream
		context: execData. 

!

printJavaIfFalseOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	| msgArgs |
	msgArgs := self arguments. 
	aStream nextPutAll: 'if ('. 
	receiver 
		printJavaWithParenthesisOn: aStream 
		context: execData.
	aStream nextPutAll: ' !!= true) '.
	(msgArgs at: 1)
		printJavaBlockOn: aStream
		context: execData. 
!

printJavaIfTrueIfFalseOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	| msgArgs |
	msgArgs := self arguments. 
	aStream nextPutAll: 'if ('. 
	receiver 
		printJavaOn: aStream 
		context: execData.
	aStream nextPutAll: ') '.
	(msgArgs at: 1)
		printJavaBlockOn: aStream
		context: execData. 
	aStream nextPutAll: ' else '.
	(msgArgs at: 2)
		printJavaBlockOn: aStream
		context: execData. 

!

printJavaIfTrueOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	| msgArgs |
	msgArgs := self arguments. 
	aStream nextPutAll: 'if ('. 
	receiver 
		printJavaOn: aStream 
		context: execData.
	aStream nextPutAll: ') '.
	(msgArgs at: 1)
		printJavaBlockOn: aStream
		context: execData. 

!

printJavaNormalOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	| msgArgs |
	receiver 
		printJavaWithParenthesisOn: aStream 
		context: execData.
	aStream 
		nextPut: $.;
		nextPutAll: (selector rtcPerformUsing: execData) asJavaSelector;
		nextPut: $(.
	(msgArgs := self arguments) size = 1 ifTrue: [
		msgArgs first
			printJavaOn: aStream
			context: execData. 
	] ifFalse: [
		RtcPortal sequenceableCollection: msgArgs doWithIndex: [:argument :index |
			argument
				printJavaWithParenthesisOn: aStream
				context: execData. 
			(index < msgArgs size)
				ifTrue: [ aStream nextPutAll: ', ' ].
		].
	].
	aStream nextPut: $).!

printJavaOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	| sel |
	sel := selector rtcPerformUsing: execData.
	sel = #ifTrue: ifTrue: [ ^self printJavaIfTrueOn: aStream context: execData receiver: receiver ].
	sel = #ifFalse: ifTrue: [ ^self printJavaIfFalseOn: aStream context: execData receiver: receiver ].
	sel = #ifTrue:ifFalse: ifTrue: [ ^self printJavaIfTrueIfFalseOn: aStream context: execData receiver: receiver ].
	sel = #ifFalse:ifTrue: ifTrue: [ ^self printJavaIfFalseIfTrueOn: aStream context: execData receiver: receiver ].
	sel = #whileTrue: ifTrue: [ ^self printJavaWhileTrueOn: aStream context: execData receiver: receiver ].
	sel = #whileFalse: ifTrue: [ ^self printJavaWhileFalseOn: aStream context: execData receiver: receiver ].
	sel = #and: ifTrue: [ ^self printJavaAndOn: aStream context: execData receiver: receiver ].
	sel = #or: ifTrue: [ ^self printJavaOrOn: aStream context: execData receiver: receiver ].
	sel = #to:do: ifTrue: [ ^self printJavaToDoOn: aStream context: execData receiver: receiver ].
	sel = #'bitAnd:' ifTrue: [ ^self printJavaSelector: #'&' on: aStream context: execData receiver: receiver ].
	sel = #'bitOr:' ifTrue: [ ^self printJavaSelector: #'|' on: aStream context: execData receiver: receiver ].
	sel = #'bitXor:' ifTrue: [ ^self printJavaSelector: #'^' on: aStream context: execData receiver: receiver ].
	^self printJavaNormalOn: aStream context: execData receiver: receiver!

printJavaOrOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	| aBlock |
	aBlock := self arguments at: 1.
	aBlock statements size > 1 
		ifTrue: [ ^self printJavaNormalOn: aStream context: execData receiver: receiver ].
	receiver 
		printJavaWithParenthesisOn: aStream 
		context: execData.
	aStream nextPutAll: ' || '.
	"Note: This can print more () than necessary."
	aStream nextPut: $(.
	aBlock
		printJavaBlockOn: aStream
		context: execData. 
	aStream nextPut: $).

!

printJavaToDoOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	| msgArgs blockVar |
	msgArgs := self arguments.
	blockVar := (msgArgs at: 2) arguments first. 
	aStream 
		nextPutAll: 'for (int ';
		nextPutAll: blockVar; 
		nextPutAll: ' = '.
	receiver 
		printJavaWithParenthesisOn: aStream 
		context: execData.
	aStream 
		nextPutAll: '; ';
		nextPutAll: blockVar;
		nextPutAll: ' <= '. 
	(msgArgs at: 1)
		printJavaWithParenthesisOn: aStream
		context: execData. 
	aStream 
		nextPutAll: '; ';
		nextPutAll: blockVar; 
		nextPutAll: '++) '.
	(msgArgs at: 2)
		printJavaBlockWithoutArgsOn: aStream
		context: execData. 

!

printJavaWhileFalseOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	| msgArgs |
	msgArgs := self arguments. 
	aStream nextPutAll: 'while (('. 
	receiver 
		printJavaBlockOn: aStream 
		context: execData.
	aStream nextPutAll: ') !!= true) '.
	(msgArgs at: 1)
		printJavaBlockOn: aStream
		context: execData. 

!

printJavaWhileTrueOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	| msgArgs |
	msgArgs := self arguments. 
	aStream nextPutAll: 'while ('. 
	receiver 
		printJavaBlockOn: aStream 
		context: execData.
	aStream nextPutAll: ') '.
	(msgArgs at: 1)
		printJavaBlockOn: aStream
		context: execData. 

!

printSTOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	| keywords msgArgs index |
	keywords := RtcPortal characterCollectionAsArrayOfKeywords: (selector rtcPerformUsing: execData).
	msgArgs := self arguments.
	index := 1.
	[	(index <= keywords size) or: 
		[index <= msgArgs size] 
	] whileTrue: [
		(index <= keywords size) ifTrue: [ 
			(index > 1) ifTrue: [ aStream space ].
			aStream nextPutAll: (keywords at: index). 
		].
		(index <= msgArgs size) ifTrue: [ 
			aStream space.
			(msgArgs at: index) 
				printSTWithParenthesisOn: aStream 
				context: execData. 
		].
		index := index + 1.
	].!

showJavaParenthesis

	^true!

showSTParenthesis

	^true! !

!RtcMessageCascade methodsFor: 'RtcScriptSupport'!

showJavaParenthesis
	"This may not be the correct thing to do for Java. It has not
	 yet been determined how to execute a message cascade in Java
	 that will answer the result of the last message send."

	self size > 1 ifTrue: [^true].
	self cascadesDo: [:msg | msg showJavaParenthesis ifTrue: [^true] ].
	^false

!

showSTParenthesis

	self size > 1 ifTrue: [^true].
	self cascadesDo: [:msg | msg showSTParenthesis ifTrue: [^true] ].
	^false

! !

!RtcMethodExit methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData

	aStream nextPutAll: 'return '.
	executable 
		printJavaOn: aStream 
		context: execData.
!

printSTOn: aStream context: execData

	aStream nextPut: $^.
	executable 
		printSTOn: aStream 
		context: execData.
! !

!RtcMethodIndexedVariable methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData

	(execData methodData size >= indexOffset) 
	ifFalse: [ self printOn: aStream ]
	ifTrue: [ 
		(execData methodDataAt: indexOffset) 
			printJavaOn: aStream 
			context: execData 
	]
 
!

printSTOn: aStream context: execData

	(execData methodData size >= indexOffset) 
	ifFalse: [ self printOn: aStream ]
	ifTrue: [ 
		(execData methodDataAt: indexOffset) 
			printSTOn: aStream 
			context: execData 
	]
 
! !

!RtcNamespaceReference methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData

	aStream 
		nextPutAll: self namespace;
		nextPutAll: '::';
		nextPutAll: self key.

"	executable 
		printJavaOn: aStream 
		context: execData.
"!

printSTOn: aStream context: execData

	aStream 
		nextPutAll: self namespace;
		nextPutAll: '::';
		nextPutAll: self key.

"	executable 
		printJavaOn: aStream 
		context: execData.
"! !

!RtcReference methodsFor: 'RtcScriptSupport'!

javaKey

	^self key
!

printJavaOn: aStream context: execData

	aStream nextPutAll: self javaKey.
 
!

printSTOn: aStream context: execData

	aStream nextPutAll: self stKey.
 
!

stKey

	^self key
! !

!RtcSuperclassMessage methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	"It has not yet been determined if Java will support the
	 execution of multiple statements within parenthesis. This may
	 not work. The last cascade must return a value for the receiver."

	self size > 1 ifTrue: [ aStream nextPut: $( ].
	self cascadesDoWithIndex: [:anExpression :index |
		anExpression 
			printJavaOn: aStream 
			context: execData
			receiver: 'super'.
		index < self size ifTrue: [ aStream nextPut: $;; space ].
	].
	self size > 1 ifTrue: [ aStream nextPut: $) ].
!

printSTOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	aStream nextPutAll: 'super'.
	self cascadesDoWithIndex: [:anExpression :index |
		(self size > 1) 
			ifTrue:  [ aStream cr; tab ]
			ifFalse: [ aStream space ].
		anExpression 
			printSTOn: aStream 
			context: execData.
		index < self size 
			ifTrue: [ aStream nextPut: $; ].
	].
! !

!RtcUnaryMessage methodsFor: 'RtcScriptSupport'!

printJavaNewOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	aStream 
		nextPutAll: (selector rtcPerformUsing: execData);
		space.
	receiver 
		printJavaWithParenthesisOn: aStream 
		context: execData.

!

printJavaNormalOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	receiver 
		printJavaWithParenthesisOn: aStream 
		context: execData.
	aStream 
		nextPut: $.;
		nextPutAll: (selector rtcPerformUsing: execData);
		nextPutAll: '()'.


!

printJavaOn: aStream context: execData receiver: receiver
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	(selector rtcPerformUsing: execData) = #basicNew 
		ifTrue: [ self printJavaNewOn: aStream context: execData receiver: receiver ]
		ifFalse: [ self printJavaNormalOn: aStream context: execData receiver: receiver ].
!

printSTOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	aStream nextPutAll: (selector rtcPerformUsing: execData)

! !

!RtcVariableAssignment methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData

	instanceVariableReference 
		printJavaOn: aStream 
		context: execData.
	aStream nextPutAll: ' = '.
	executable 
		printJavaOn: aStream 
		context: execData.
!

printJavaWithParenthesisOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	aStream nextPut: $(.
	self printJavaOn: aStream context: execData.
	aStream nextPut: $).
!

printSTOn: aStream context: execData

	instanceVariableReference 
		printSTOn: aStream 
		context: execData.
	aStream nextPutAll: ' := '.
	executable 
		printSTOn: aStream 
		context: execData.
!

printSTWithParenthesisOn: aStream context: execData
	"Append to the argument aStream, a sequence of characters that
	 describes the receiver."

	aStream nextPut: $(.
	self printSTOn: aStream context: execData.
	aStream nextPut: $).
! !

!String methodsFor: 'RtcScriptSupport'!

asJavaSelector

	| answer |
	answer := self copyReplacing: $: withObject: $_ .
	^(answer last = $_) 
		ifFalse: [ answer ]
		ifTrue: [ answer copyFrom: 1 to: answer size - 1 ].
!

printJavaOn: aStream context: execData

	aStream nextPut: $".
	self do: [:char |char printJavaTokenOn: aStream ].
	aStream nextPut: $".
! !

!UndefinedObject methodsFor: 'RtcScriptSupport'!

printJavaOn: aStream context: execData

	aStream nextPutAll: 'null'.

! !

!VariableBinding methodsFor: 'RtcScriptSupportVW'!

printJavaOn: aStream context: execData

	aStream nextPutAll: self key
!

printSTOn: aStream context: execData

	aStream nextPutAll: self key
! !


"	***** Class initialization *****	"!

RtcPortableBehavior initialize.!

"	***** Post-load code *****	"!

"RtcProxyMethodSupportVW"
RtcCompiledMethodProxy initializeProxyMethodTemplates.!

"RtcPortableBehaviors"
RtcPortableBehavior initialize.!

"PlbOperationModelSupport"
"  self loaded  "

	RtcPortableBehavior initialize.
	(RtcPortal vmTypeName = #VisualAge)
		ifTrue: [self initializeExceptions].!
"	***** End of file *****	"!