"Description: 
An install script for SoapOpera 0.6 + VWXML
Edit settings and file-in.

Copyright (C) 2003 Masashi Umezawa

Prerequisites:
Comanche or ComancheNG

How to install: 
0: Install prerequisites from SqueakMap.
1: Put the directory named: 'installSoapOpera0.6' under your Squeak home direcotry.
2: In order to select file-in components, edit settings below.
3: From the file list, just file in this file.

"!

"settings -  edit if you like"
dir := 'installSoapOpera0.6'.
xmlParserInstall := true.
soapOperaInstall := true.

"install main - edit if you like (normally you don't have to)"
rootPath := (FileDirectory default fullNameFor: dir), FileDirectory slash.
xmlParserCorePath := rootPath, 'VWXMLforSqueak3.x', FileDirectory slash, 'Repackaged VWXML'.
xmlParserExtPath := rootPath, 'VWXMLforSqueak3.x', FileDirectory slash, 'MU VWXML extension'.

xmlParserCore := #(
'VWXML.1.cs'
'VWXMLTweaks.1.cs'
).

xmlParserExt := #(
'VWXML-Extension-Base.1.cs'
).

xmlParserInstall ifTrue:[
xmlParserCore do:[:each | ((FileDirectory on: xmlParserCorePath) readOnlyFileNamed: each) fileIn.].
xmlParserExt do:[:each | ((FileDirectory on: xmlParserExtPath) readOnlyFileNamed: each) fileIn.].
].

soapOperaInstall ifTrue:[
((FileDirectory on: rootPath) readOnlyFileNamed: 'install-all.st') fileIn.
].

!

"program initialization"
SoXmlUtil parserAdapter: SoVWXMLParserAdapter.
SoapConfigurationMap initializeAll.

Transcript cr; show: 'SoapOpera0.6 + VWXML installation succeeded'.
Smalltalk changes name: 'SoapOpera0.6-20031010-vwxml'.
! 

"end of script"!
