"Description: 
An install script for OperaORB 0.6
Edit settings and file-in.

Copyright (C) 2002-2003 Masashi Umezawa

Prerequisites:
SoapCore Client/Server

How to install: 
1: Create a new directory named: 'installSoapOpera0.6' under your Squeak home direcotry.
2: Copy all needed files to the directory. (installOperaORB.st, [OperaORB])
3: From the file list, just file in this file.

"!

"settings -  edit if you like"
dir := 'installSoapOpera0.6'.
operaInstall := true.

"install main - edit if you like (normally you don't have to)"
rootPath := (FileDirectory default fullNameFor: dir), FileDirectory slash.
operaPath := rootPath,'OperaORB'.

opera := #(
'Opera-Base.st'
'Opera-Error.st'
'Opera-Connector.st'
'Opera-Server.st'
'Opera-Example.st'
'Opera-TestCases.st'
).

operaInstall ifTrue:[
opera do:[:each | ((FileDirectory on: operaPath) readOnlyFileNamed: each) fileIn.].
].
!

"program initialization"
Smalltalk at: #OperaPortableUtil ifPresent:[:val | OperaPortableUtil installRootOOA.].

Transcript cr; show: 'OperaORB installation succeeded'.
! 

"end of script"!
